/******************************************************************************************
 * Fitxer:AlumneDetails.java
 * Data Creaci:08-ene-2014
 * Ultima Modificacio: 08-ene-2014
 * Autor:Toms Ruiz
 * Projecte: TUTOC - Aplicaci Android enfocada a la gesti dels tutors a UOC
 * Assignatura:TFC-Desenvolupament aplicacions dispositius mbils (Android) Aula 3
 * Consultor:Joan Vicent  Orenga  Serisuelo
 * Descripci:
 * Log:
****************************************************************************************** */
package edu.uoc.tutoc;

import java.io.InputStream;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.HttpStatus;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;

import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

import com.google.gson.Gson;

import edu.uoc.tutoc.alumne.Alumne;
import edu.uoc.tutoc.aplicacio.Applicacio;
import edu.uoc.tutoc.bustia.CorreuElectronic;

/**
 * El Class AlumneDetails.
 */
public class AlumneDetails extends Activity {
	private CorreuElectronic missatge = new CorreuElectronic();
	private static Alumne alumne = new Alumne();
	public static final String URL = alumne.getPhotoUrl();
	private ProgressDialog simpleWaitDialog;
	ImageView imageView;

	/**
	 * On btn envia.
	 * 
	 * @param v
	 *            : v
	 * @return void
	 * @desc On btn envia.
	 */
	public void onBtnEnvia(View v) {
		missatge.setTo(alumne.getEmail());
		if (Applicacio.getInstance().getToken() != null) {

			Intent intent = new Intent(AlumneDetails.this, MailNewMessage.class);
			Bundle b = new Bundle();
			String aulaJson = (new Gson()).toJson(missatge);
			b.putString("MISSATGE", aulaJson);
			intent.putExtras(b);
			startActivity(intent);
		} else {
			Toast toast1 = Toast.makeText(getApplicationContext(),
					getString(R.string.Err_necessariConnectar),
					Toast.LENGTH_SHORT);
			toast1.show();
		}
	}

	/**
	 * Called when the activity is first created.
	 * 
	 * @param savedInstanceState
	 *            : saved instance state
	 * @return void
	 * @desc On create.
	 */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.alumnedetails_layout);
		imageView = (ImageView) findViewById(R.id.alumnedetails_imatgeAlumne);
		// Obtenemos el parametro de entrada
		Bundle bundle = getIntent().getExtras();
		String parametreJSON = bundle.getString("ALUMNE");
		alumne = new Gson().fromJson(parametreJSON, Alumne.class);
		String URL2 = alumne.getPhotoUrl();
		// Cargamos controles
		TextView txtTemp = (TextView) (findViewById(R.id.alumnedetails_txtFullNameAlumne));
		txtTemp.setText(alumne.getFullName());
		txtTemp = (TextView) (findViewById(R.id.alumnedetails_txtIdioma));
		txtTemp.setText(alumne.getLanguage());
		txtTemp = (TextView) (findViewById(R.id.alumnedetails_txtIdUOC));
		txtTemp.setText(alumne.getId());
		txtTemp = (TextView) (findViewById(R.id.alumnedetails_txtUserName));
		txtTemp.setText(alumne.getUsername());

		GetXMLTask task = new GetXMLTask();

		Log.v("Cargar Imagen", URL2);
		task.execute(new String[] { URL2 });
	}

	/**
	 * El Class GetXMLTask.
	 */
	private class GetXMLTask extends AsyncTask<String, Void, Bitmap> {
		@Override
		protected Bitmap doInBackground(String... urls) {
			Bitmap map = null;
			for (String url : urls) {
				map = downloadImage(url);
			}
			return map;
		}

		/**
		 * @desc Mtode sobrescrigut de @see android.os.AsyncTask#onPostExecute(java.lang.Object) 
		 * <p>
		 * @version: 1.0
		 * @autor: Toms Ruiz
		 * @params:
		 * @return: el valor de
		 * @exception:
		 * @see: @see android.os.AsyncTask#onPostExecute(java.lang.Object)
		 * @see [String]
		 * @see [URL]
		 * @see [Class name#method name]
		 * @example
		 * @todo
		 * @precondition
		 * @postcondition
		 * @summary
		 * @bug
		
		*/
		
		@Override
		protected void onPostExecute(Bitmap result) {
			Log.i("Carregnat Imatge", "Crida onPostExecute");
			if (result == null) {
				imageView.setImageResource(R.drawable.ic_contact);
				Log.v("Cargar_Imagen", "Cargamos el resource");
			} else {
				imageView.setImageBitmap(result);
			}
			simpleWaitDialog.dismiss();
		}

		/**
		 * @desc Mtode sobrescrigut de @see android.os.AsyncTask#onPreExecute() 
		 * <p>
		 * @version: 1.0
		 * @autor: Toms Ruiz
		 * @params:
		 * @return: el valor de
		 * @exception:
		 * @see: @see android.os.AsyncTask#onPreExecute()
		 * @see [String]
		 * @see [URL]
		 * @see [Class name#method name]
		 * @example
		 * @todo
		 * @precondition
		 * @postcondition
		 * @summary
		 * @bug
		
		*/
		
		protected void onPreExecute() {
			Log.i("Carregnat Imatge", "Crida onPreExecute");
			simpleWaitDialog = ProgressDialog.show(AlumneDetails.this,
					"Treballant", "Carregant foto perfil");

		}

		/**
		 * Download image.
		 * 
		 * @param url
		 *            : url
		 * @return bitmap Tipus: AlumneDetails
		 */
		private Bitmap downloadImage(String url) {
			final DefaultHttpClient client = new DefaultHttpClient();
			final HttpGet getRequest = new HttpGet(url);
			try {

				HttpResponse response = client.execute(getRequest);

				final int statusCode = response.getStatusLine().getStatusCode();

				if (statusCode != HttpStatus.SC_OK) {
					Log.w("ImageDownloader", "Error " + statusCode
							+ " while retrieving bitmap from " + url);
					return null;

				}

				final HttpEntity entity = response.getEntity();
				if (entity != null) {
					InputStream inputStream = null;
					try {

						inputStream = entity.getContent();

						final Bitmap bitmap = BitmapFactory
								.decodeStream(inputStream);

						return bitmap;
					} finally {
						if (inputStream != null) {
							inputStream.close();
						}
						entity.consumeContent();
					}
				}
			} catch (Exception e) {

				getRequest.abort();
				Log.e("Carregar Imatger", "Error"
						+ " quan importava la imatge " + url + e.toString());
			}

			return null;
		}

	}
}
