/******************************************************************************************
 * Fitxer:Alumnes.java
 * Data Creaci:1-dic-2013
 * Ultima Modificacio: 10-dic-2013
 * Autor:Toms Ruiz
 * Projecte: TUTOC - Aplicaci Android enfocada a la gesti dels tutors a UOC
 * Assignatura:TFC-Desenvolupament aplicacions dispositius mbils (Android) Aula 3
 * Consultor:Joan Vicent  Orenga  Serisuelo
 * Descripci:
 * Log:
 ****************************************************************************************** */
package edu.uoc.tutoc;

import java.util.ArrayList;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ListView;

import com.google.gson.Gson;

import edu.uoc.tutoc.alumne.Alumne;
import edu.uoc.tutoc.alumne.adaptadorLlistaAlumnes;
import edu.uoc.tutoc.test.JocProves;

/**
 * El Class Alumnes.
 */
public class Alumnes extends Activity {

	/**
	 * @desc Mtode sobrescrigut de @see
	 *       android.app.Activity#onCreate(android.os.Bundle)
	 *       <p>
	 * @version: 1.0
	 * @autor: Toms Ruiz
	 * @params:
	 * @return: el valor de
	 * @exception:
	 * @see: @see android.app.Activity#onCreate(android.os.Bundle)
	 * @see [String]
	 * @see [URL]
	 * @see [Class name#method name]
	 * @example
	 * @todo
	 * @precondition
	 * @postcondition
	 * @summary
	 * @bug
	 */

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_alumnes);
		ArrayList<Alumne> alumnes = JocProves.getInstance().getAlumnes();
		ListView llistaAlumnes = (ListView) findViewById(R.id.activityAlumnesLlistaAlumnes);
		llistaAlumnes.setAdapter(new adaptadorLlistaAlumnes(this, alumnes));
		llistaAlumnes.setItemsCanFocus(true);
		llistaAlumnes.setOnItemClickListener(new OnItemClickListener() {

			@Override
			public void onItemClick(AdapterView<?> arg0, View arg1, int arg2,
					long arg3) {
				Log.v("Alumne", "Has entrat en el ONClick");
				Alumne alumne = (Alumne) arg0.getAdapter().getItem(arg2);
				Intent intent = new Intent(Alumnes.this, AlumneView.class);
				Bundle b = new Bundle();
				String alumneJson = (new Gson()).toJson(alumne);
				b.putString("alumne", alumneJson);
				intent.putExtras(b);
				startActivity(intent);

			}
		});
	}

	/**
	 * @desc Mtode sobrescrigut de @see
	 *       android.app.Activity#onCreateOptionsMenu(android.view.Menu)
	 *       <p>
	 * @version: 1.0
	 * @autor: Toms Ruiz
	 * @params:
	 * @return: el valor de
	 * @exception:
	 * @see: @see android.app.Activity#onCreateOptionsMenu(android.view.Menu)
	 * @see [String]
	 * @see [URL]
	 * @see [Class name#method name]
	 * @example
	 * @todo
	 * @precondition
	 * @postcondition
	 * @summary
	 * @bug
	 */

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.alumnes, menu);
		return true;
	}

}
