/******************************************************************************************
 * Fitxer:AlumnesLlistaActivity.java
 * Data Creaci:08-ene-2014
 * Ultima Modificacio: 08-ene-2014
 * Autor:Toms Ruiz
 * Projecte: TUTOC - Aplicaci Android enfocada a la gesti dels tutors a UOC
 * Assignatura:TFC-Desenvolupament aplicacions dispositius mbils (Android) Aula 3
 * Consultor:Joan Vicent  Orenga  Serisuelo
 * Descripci:
 * Log:
 ****************************************************************************************** */
package edu.uoc.tutoc;

import java.util.ArrayList;

import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Intent;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

import com.google.gson.Gson;

import edu.uoc.tutoc.alumne.Alumne;
import edu.uoc.tutoc.alumne.AlumneLlista;
import edu.uoc.tutoc.alumne.adaptadorLlistaAlumnes;
import edu.uoc.tutoc.api.rest.RESTMethod;
import edu.uoc.tutoc.aplicacio.Applicacio;
import edu.uoc.tutoc.aula.Aula;

/**
 * El Class AlumnesLlistaActivity.
 */
public class AlumnesLlistaActivity extends Activity {

	/** El aula. */
	private Aula aula = new Aula();

	/**
	 * @desc Mtode sobrescrigut de @see
	 *       android.app.Activity#onCreate(android.os.Bundle)
	 *       <p>
	 * @version: 1.0
	 * @autor: Toms Ruiz
	 * @params:
	 * @return: el valor de
	 * @exception:
	 * @see: @see android.app.Activity#onCreate(android.os.Bundle)
	 * @see [String]
	 * @see [URL]
	 * @see [Class name#method name]
	 * @example
	 * @todo
	 * @precondition
	 * @postcondition
	 * @summary
	 * @bug
	 */

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_alumnes);
		aula = new Aula();
		Bundle bundle = getIntent().getExtras();
		String parametreJSON = bundle.getString("AULA");
		aula = new Gson().fromJson(parametreJSON, Aula.class);
		TextView txtNomAula = (TextView) (findViewById(R.id.activityAlumnes_txtNomAula));
		Toast.makeText(this, aula.getTitle(), Toast.LENGTH_SHORT).show();
		txtNomAula.setText(aula.getTitle());
		getAlumnes tascaAPI = new getAlumnes();
		tascaAPI.execute();
	}

	/**
	 * @desc Mtode sobrescrigut de @see
	 *       android.app.Activity#onCreateOptionsMenu(android.view.Menu)
	 *       <p>
	 * @version: 1.0
	 * @autor: Toms Ruiz
	 * @params:
	 * @return: el valor de
	 * @exception:
	 * @see: @see android.app.Activity#onCreateOptionsMenu(android.view.Menu)
	 * @see [String]
	 * @see [URL]
	 * @see [Class name#method name]
	 * @example
	 * @todo
	 * @precondition
	 * @postcondition
	 * @summary
	 * @bug
	 */

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.alumne, menu);
		return true;
	}

	/**
	 * El Class getAules.
	 */
	private class getAlumnes extends AsyncTask<String, Void, String> {

		/** El progres. */
		private ProgressDialog progres;

		/**
		 * Do in background.
		 * 
		 * @param params
		 *            : params
		 * @return string Tipus: AlumnesLlistaActivity
		 * @desc Mtode sobrescrigut de @see
		 *       android.os.AsyncTask#doInBackground(Params[])
		 *       <p>
		 * @version: 1.0
		 * @autor: Toms Ruiz
		 * @params:
		 * @return: el valor de
		 * @exception:
		 * @see: @see android.os.AsyncTask#doInBackground(Params[])
		 * @see [String]
		 * @see [URL]
		 * @see [Class name#method name]
		 * @example
		 * @todo
		 * @precondition
		 * @postcondition
		 * @summary
		 * @bug
		 */

		@Override
		protected String doInBackground(String... params) {
			String resultat = RESTMethod.Get(
					"/api/v1/classrooms/" + aula.getId() + "/people/students",
					Applicacio.getInstance().getToken());
			Log.v("LOGIN", "JSON RESULTANT LOGIN:" + resultat);

			return resultat;
		}

		/**
		 * On post execute.
		 * 
		 * @param result
		 *            : result
		 * @return void
		 * @desc Mtode sobrescrigut de @see
		 *       android.os.AsyncTask#onPostExecute(java.lang.Object)
		 *       <p>
		 * @version: 1.0
		 * @autor: Toms Ruiz
		 * @params:
		 * @return: el valor de
		 * @exception:
		 * @see: @see android.os.AsyncTask#onPostExecute(java.lang.Object)
		 * @see [String]
		 * @see [URL]
		 * @see [Class name#method name]
		 * @example
		 * @todo
		 * @precondition
		 * @postcondition
		 * @summary
		 * @bug
		 */

		@Override
		protected void onPostExecute(String result) {
			super.onPostExecute(result);
			AlumneLlista alumneLlista = AlumneLlista.JSONtoUserList(result);// sempre
																			// que
																			// la
																			// classe
																			// sigui
																			// esttica
																			// no
																			// es
																			// necessari
																			// instanciar
																			// er
																			// cridar
			ArrayList<Alumne> alumnes = alumneLlista.getUsers();
			Log.v("alumnes", "mida " + alumnes.size());
			ListView llistaAlumnes = (ListView) findViewById(R.id.activityAlumnesLlistaAlumnes);
			llistaAlumnes.setAdapter(new adaptadorLlistaAlumnes(
					AlumnesLlistaActivity.this, alumnes));
			llistaAlumnes.setItemsCanFocus(true);
			llistaAlumnes.setOnItemClickListener(new OnItemClickListener() {

				@Override
				public void onItemClick(AdapterView<?> arg0, View arg1,
						int arg2, long arg3) {
					Alumne alumne = (Alumne) arg0.getAdapter().getItem(arg2);
					Intent intent = new Intent(AlumnesLlistaActivity.this,
							AlumneDetails.class);
					Bundle b = new Bundle();
					String conversioJSON = (new Gson()).toJson(alumne);
					b.putString("ALUMNE", conversioJSON);
					intent.putExtras(b);
					startActivity(intent);
				}

			});

			progres.dismiss();
		}

		/**
		 * On pre execute.
		 * 
		 * @return void
		 * @desc Mtode sobrescrigut de @see android.os.AsyncTask#onPreExecute()
		 *       <p>
		 * @version: 1.0
		 * @autor: Toms Ruiz
		 * @params:
		 * @return: el valor de
		 * @exception:
		 * @see: @see android.os.AsyncTask#onPreExecute()
		 * @see [String]
		 * @see [URL]
		 * @see [Class name#method name]
		 * @example
		 * @todo
		 * @precondition
		 * @postcondition
		 * @summary
		 * @bug
		 */

		@Override
		protected void onPreExecute() {

			super.onPreExecute();
			progres = ProgressDialog.show(AlumnesLlistaActivity.this,
					"Carregant", "Carregant-ho...");
		}
	}

}
