/******************************************************************************************
 * Fitxer:AulaView.java
 * Data Creaci:08-ene-2014
 * Ultima Modificacio: 08-ene-2014
 * Autor:Toms Ruiz
 * Projecte: TUTOC - Aplicaci Android enfocada a la gesti dels tutors a UOC
 * Assignatura:TFC-Desenvolupament aplicacions dispositius mbils (Android) Aula 3
 * Consultor:Joan Vicent  Orenga  Serisuelo
 * Descripci:
 * Log:
 ****************************************************************************************** */
package edu.uoc.tutoc;

import com.google.gson.Gson;

import edu.uoc.tutoc.aula.Aula;
import android.os.Bundle;
import android.app.Activity;
import android.content.Intent;
import android.graphics.Color;
import android.util.Log;
import android.view.Menu;
import android.view.View;
import android.widget.TextView;

public class AulaView extends Activity {

	/** Camp Aula. */
	private Aula aula;

	/**
	 * @desc Mtode sobrescrigut de @see
	 *       android.app.Activity#onCreate(android.os.Bundle)
	 *       <p>
	 * @version: 1.0
	 * @autor: Toms Ruiz
	 * @params:
	 * @return: el valor de
	 * @exception:
	 * @see: @see android.app.Activity#onCreate(android.os.Bundle)
	 * @see [String]
	 * @see [URL]
	 * @see [Class name#method name]
	 * @example
	 * @todo
	 * @precondition
	 * @postcondition
	 * @summary
	 * @bug
	 */

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.fitxaaula);
		String parametre = getIntent().getExtras().getString("AULA");
		aula = new Gson().fromJson(parametre, Aula.class);
		TextView nom_aula = (TextView) findViewById(R.id.activityFitxaAula_txtNomAula);
		nom_aula.setText(aula.getTitle());
		nom_aula.setBackgroundColor(Color.parseColor(aula.getColor()));

	}

	/**
	 * On create options menu.
	 * 
	 * @param menu
	 *            : menu
	 * @return true, si es correcte
	 * @desc Mtode sobrescrigut de @see
	 *       android.app.Activity#onCreateOptionsMenu(android.view.Menu)
	 *       <p>
	 * @version: 1.0
	 * @autor: Toms Ruiz
	 * @params:
	 * @return: el valor de
	 * @exception:
	 * @see: @see android.app.Activity#onCreateOptionsMenu(android.view.Menu)
	 * @see [String]
	 * @see [URL]
	 * @see [Class name#method name]
	 * @example
	 * @todo
	 * @precondition
	 * @postcondition
	 * @summary
	 * @bug
	 */

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.aula, menu);
		return true;
	}

	/**
	 * Eventalumnes.
	 * 
	 * @param view
	 *            : view
	 * @return void
	 * @desc Eventalumnes.
	 */
	public void eventalumnes(View view) {
		Log.v("Aula", "Ha fet clic a la aula hem de cridar als alumnes");
		Intent intent = new Intent(AulaView.this, AlumnesLlistaActivity.class);
		Bundle b = new Bundle();
		String aulaJson = (new Gson()).toJson(aula);
		b.putString("AULA", aulaJson);
		intent.putExtras(b);
		startActivity(intent);

	}

	/**
	 * Event forum.
	 * 
	 * @param view
	 *            : view
	 * @return void
	 * @desc Event forum.
	 */
	public void eventForum(View view) {
		Log.v("Aula", "Ha fet clic a la aula per cridar forum");
		Intent intent = new Intent(AulaView.this, BoardListActivity.class);
		Bundle b = new Bundle();
		String aulaJson = (new Gson()).toJson(aula);
		b.putString("AULA", aulaJson);
		intent.putExtras(b);
		startActivity(intent);

	}
}
