/******************************************************************************************
 * Fitxer:AulesActivity.java
 * Data Creaci:08-ene-2014
 * Ultima Modificacio: 08-ene-2014
 * Autor:Toms Ruiz
 * Projecte: TUTOC - Aplicaci Android enfocada a la gesti dels tutors a UOC
 * Assignatura:TFC-Desenvolupament aplicacions dispositius mbils (Android) Aula 3
 * Consultor:Joan Vicent  Orenga  Serisuelo
 * Descripci:
 * Log:
 ****************************************************************************************** */
package edu.uoc.tutoc;

import java.util.ArrayList;

import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Intent;
import android.content.res.Configuration;
import android.os.AsyncTask;
import android.os.Bundle;
import android.support.v4.app.ActionBarDrawerToggle;
import android.support.v4.widget.DrawerLayout;
import android.util.Log;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Toast;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ListView;

import com.google.gson.Gson;

import edu.uoc.tutoc.api.rest.RESTMethod;
import edu.uoc.tutoc.aplicacio.Applicacio;
import edu.uoc.tutoc.aplicacio.Tutor;
import edu.uoc.tutoc.aula.Aula;
import edu.uoc.tutoc.aula.AulaLlista;
import edu.uoc.tutoc.aula.adaptadorLlistaAules;
import edu.uoc.tutoc.bustia.CarpetaCorreuElectronicLlista;
import edu.uoc.tutoc.bustia.CorreuElectronicLlista;
import edu.uoc.tutoc.test.JocProves;

/**
 * El Class AulesActivity.
 */
public class AulesActivity extends Activity {
	private DrawerLayout mDrawerLayout;
	private ListView mDrawerList;
	private ActionBarDrawerToggle mDrawerToggle;

	private CharSequence mDrawerTitle;
	private CharSequence mTitle;
	private String[] mOpcionesMenu;
	private Tutor propietari = new Tutor();

	/**
	 * @desc Mtode sobrescrigut de @see
	 *       android.app.Activity#onCreate(android.os.Bundle)
	 *       <p>
	 * @version: 1.0
	 * @autor: Toms Ruiz
	 * @params:
	 * @return: el valor de
	 * @exception:
	 * @see: @see android.app.Activity#onCreate(android.os.Bundle)
	 * @see [String]
	 * @see [URL]
	 * @see [Class name#method name]
	 * @example
	 * @todo
	 * @precondition
	 * @postcondition
	 * @summary
	 * @bug
	 */

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_aules);

		mTitle = mDrawerTitle = getTitle();
		mOpcionesMenu = new String[] { "BUSTIA", "SORTIR" };

		mDrawerLayout = (DrawerLayout) findViewById(R.id.drawer_layout);
		mDrawerList = (ListView) findViewById(R.id.left_drawer);
		mDrawerList.setAdapter(new ArrayAdapter<String>(this,
				R.layout.drawer_item, mOpcionesMenu));
		mDrawerList.setOnItemClickListener(new DrawerItemClickListener());

		getActionBar().setDisplayHomeAsUpEnabled(true); // Per habilitar la
														// barra d'eines

		mDrawerToggle = new ActionBarDrawerToggle(this, mDrawerLayout,
				R.drawable.ic_drawer, R.string.drawer_open,
				R.string.drawer_close) {
			public void onDrawerClosed(View view) {
				getActionBar().setTitle(mDrawerTitle);
				invalidateOptionsMenu();
			}

			public void onDrawerOpened(View drawerView) {
				getActionBar().setTitle(mDrawerTitle);
				invalidateOptionsMenu();
			}
		};
		mDrawerLayout.setDrawerListener(mDrawerToggle);
		// Execuci Tasca
		new getUserTask().execute();
		new getAules().execute();
		new getMailFolderTask().execute();
		new getUnreadMails().execute();

	}

	/**
	 * @desc Mtode sobrescrigut de @see
	 *       android.app.Activity#onOptionsItemSelected(android.view.MenuItem)
	 *       <p>
	 * @version: 1.0
	 * @autor: Toms Ruiz
	 * @params:
	 * @return: el valor de
	 * @exception:
	 * @see: @see
	 *       android.app.Activity#onOptionsItemSelected(android.view.MenuItem)
	 * @see [String]
	 * @see [URL]
	 * @see [Class name#method name]
	 * @example
	 * @todo
	 * @precondition
	 * @postcondition
	 * @summary
	 * @bug
	 */

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		if (mDrawerToggle.onOptionsItemSelected(item)) {
			return true;
		} else {
			return super.onOptionsItemSelected(item);
		}
	}

	/**
	 * @desc Mtode sobrescrigut de @see
	 *       android.app.Activity#setTitle(java.lang.CharSequence)
	 *       <p>
	 * @version: 1.0
	 * @autor: Toms Ruiz
	 * @params:
	 * @return: el valor de
	 * @exception:
	 * @see: @see android.app.Activity#setTitle(java.lang.CharSequence)
	 * @see [String]
	 * @see [URL]
	 * @see [Class name#method name]
	 * @example
	 * @todo
	 * @precondition
	 * @postcondition
	 * @summary
	 * @bug
	 */

	@Override
	public void setTitle(CharSequence title) {
		mTitle = title;
		getActionBar().setTitle(mTitle);
	}

	/**
	 * @desc Mtode sobrescrigut de @see
	 *       android.app.Activity#onPostCreate(android.os.Bundle)
	 *       <p>
	 * @version: 1.0
	 * @autor: Toms Ruiz
	 * @params:
	 * @return: el valor de
	 * @exception:
	 * @see: @see android.app.Activity#onPostCreate(android.os.Bundle)
	 * @see [String]
	 * @see [URL]
	 * @see [Class name#method name]
	 * @example
	 * @todo
	 * @precondition
	 * @postcondition
	 * @summary
	 * @bug
	 */

	@Override
	protected void onPostCreate(Bundle savedInstanceState) {
		super.onPostCreate(savedInstanceState);
		mDrawerToggle.syncState();
	}

	/**
	 * @desc Mtode sobrescrigut de @see
	 *       android.app.Activity#onConfigurationChanged
	 *       (android.content.res.Configuration)
	 *       <p>
	 * @version: 1.0
	 * @autor: Toms Ruiz
	 * @params:
	 * @return: el valor de
	 * @exception:
	 * @see: @see
	 *       android.app.Activity#onConfigurationChanged(android.content.res
	 *       .Configuration)
	 * @see [String]
	 * @see [URL]
	 * @see [Class name#method name]
	 * @example
	 * @todo
	 * @precondition
	 * @postcondition
	 * @summary
	 * @bug
	 */

	@Override
	public void onConfigurationChanged(Configuration newConfig) {
		super.onConfigurationChanged(newConfig);
		mDrawerToggle.onConfigurationChanged(newConfig);
	}

	/**
	 * On click aules.
	 * 
	 * @param view
	 *            : view
	 * @return void
	 * @desc On click aules.
	 */
	public void onClickAules(View view) {
		Toast toast1 = Toast.makeText(getApplicationContext(),
				getString(R.string.Err_noAPI), Toast.LENGTH_SHORT);
		toast1.show();
	}

	/**
	 * El Class getAules.
	 */
	private class getAules extends AsyncTask<String, Void, String> {

		/** El progres. */
		private ProgressDialog progres;

		/**
		 * Do in background.
		 * 
		 * @param params
		 *            : params
		 * @return string Tipus: AulesActivity
		 * @desc Mtode sobrescrigut de @see
		 *       android.os.AsyncTask#doInBackground(Params[])
		 *       <p>
		 * @version: 1.0
		 * @autor: Toms Ruiz
		 * @params:
		 * @return: el valor de
		 * @exception:
		 * @see: @see android.os.AsyncTask#doInBackground(Params[])
		 * @see [String]
		 * @see [URL]
		 * @see [Class name#method name]
		 * @example
		 * @todo
		 * @precondition
		 * @postcondition
		 * @summary
		 * @bug
		 */

		@Override
		protected String doInBackground(String... params) {
			String resultat = RESTMethod.Get("/api/v1/classrooms", Applicacio
					.getInstance().getToken());
			Log.v("LOGIN", "JSON RESULTANT CLASSROOMS:" + resultat);

			return resultat;
		}

		/**
		 * On post execute.
		 * 
		 * @param result
		 *            : result
		 * @return void
		 * @desc Mtode sobrescrigut de @see
		 *       android.os.AsyncTask#onPostExecute(java.lang.Object)
		 *       <p>
		 * @version: 1.0
		 * @autor: Toms Ruiz
		 * @params:
		 * @return: el valor de
		 * @exception:
		 * @see: @see android.os.AsyncTask#onPostExecute(java.lang.Object)
		 * @see [String]
		 * @see [URL]
		 * @see [Class name#method name]
		 * @example
		 * @todo
		 * @precondition
		 * @postcondition
		 * @summary
		 * @bug
		 */

		@Override
		protected void onPostExecute(String result) {
			// TODO Auto-generated method stub
			super.onPostExecute(result);
			AulaLlista aulaLlista = AulaLlista.JSONtoClassroomList(result);// sempre
																			// que
																			// la
																			// classe
																			// sigui
																			// esttica
																			// no
																			// es
																			// necessari
																			// instanciar
																			// er
																			// cridar
			ArrayList<Aula> aules = aulaLlista.getClassrooms();
			Log.v("AULES", "Numero Aulas"
					+ JocProves.getInstance().getAules().size());
			ListView llistaAules = (ListView) findViewById(R.id.activityAules_llistaAules);
			llistaAules.setAdapter(new adaptadorLlistaAules(AulesActivity.this,
					aules));
			llistaAules.setItemsCanFocus(true);
			llistaAules.setOnItemClickListener(new OnItemClickListener() {

				@Override
				public void onItemClick(AdapterView<?> arg0, View arg1,
						int arg2, long arg3) {
					Aula aula = (Aula) arg0.getAdapter().getItem(arg2);
					Intent intent = new Intent(AulesActivity.this,
							AulaView.class);
					Bundle b = new Bundle();
					String conversioJSON = (new Gson()).toJson(aula);
					b.putString("AULA", conversioJSON);
					intent.putExtras(b);
					startActivity(intent);
				}

			});

			progres.dismiss();
		}

		/**
		 * On pre execute.
		 * 
		 * @return void
		 * @desc Mtode sobrescrigut de @see android.os.AsyncTask#onPreExecute()
		 *       <p>
		 * @version: 1.0
		 * @autor: Toms Ruiz
		 * @params:
		 * @return: el valor de
		 * @exception:
		 * @see: @see android.os.AsyncTask#onPreExecute()
		 * @see [String]
		 * @see [URL]
		 * @see [Class name#method name]
		 * @example
		 * @todo
		 * @precondition
		 * @postcondition
		 * @summary
		 * @bug
		 */

		@Override
		protected void onPreExecute() {

			super.onPreExecute();
			progres = ProgressDialog.show(AulesActivity.this, "Carregant",
					"Obtenint Aules...");
		}
	}

	private class DrawerItemClickListener implements
			ListView.OnItemClickListener {
		@Override
		public void onItemClick(AdapterView<?> parent, View view, int position,
				long id) {
			selectItem(position);
			mDrawerLayout.closeDrawer(mDrawerList);
		}

	}

	/**
	 * DrawerItemClickListener.selectItem
	 * 
	 * @param position
	 *            : position
	 * @return void
	 * @desc <p>
	 * @version: 1.0 - 02/01/2014
	 * @autor: Toms Ruiz
	 * @params:
	 * @return: el valor de Tipus: void
	 * @exception:
	 * @see: selectItem, DrawerItemClickListener * @see [String]
	 * @see [URL]
	 * @see [Class name#method name]
	 * @example
	 * @todo
	 * @precondition
	 * @postcondition
	 * @summary
	 * @bug
	 */

	private void selectItem(int position) {
		// TODO Desenvolupar funci
		switch (position) {
		case 0:
			startActivity(new Intent(this, CarpetesCorreus.class));
			finish();
			break;
		case 1:
			finish();
			break;
		default:
			break;
		}
	}

	/*
	 * El Class getMailFolderTask.
	 */
	/**
	 * El Class getMailFolderTask.
	 */
	private class getMailFolderTask extends AsyncTask<String, Void, Void> {

		/**
		 * @desc Mtode sobrescrigut de @see
		 *       android.os.AsyncTask#doInBackground(Params[])
		 *       <p>
		 * @version: 1.0
		 * @autor: Toms Ruiz
		 * @params:
		 * @return: el valor de
		 * @exception:
		 * @see: @see android.os.AsyncTask#doInBackground(Params[])
		 * @see [String]
		 * @see [URL]
		 * @see [Class name#method name]
		 * @example
		 * @todo
		 * @precondition
		 * @postcondition
		 * @summary
		 * @bug
		 */

		@Override
		protected Void doInBackground(String... params) {

			String resultat = RESTMethod.Get("/api/v1/mail/folders", Applicacio
					.getInstance().getToken());
			Log.v("LOGIN", "JSON RESULTANT LOGIN:" + resultat);
			JocProves.getInstance().setCarpetes(
					CarpetaCorreuElectronicLlista.JSONtoFolderList(resultat)
							.getFolders());
			return null;
		}
	}

	private class getUserTask extends AsyncTask<String, Void, String> {
		private ProgressDialog progres;

		/**
		 * On pre execute.
		 * 
		 * @return void
		 * @desc Mtode sobrescrigut de @see
		 *       android.os.AsyncTask#doInBackground(Params[])
		 *       <p>
		 * @version: 1.0
		 * @autor: Toms Ruiz
		 * @params:
		 * @return: el valor de
		 * @exception:
		 * @see: @see android.os.AsyncTask#doInBackground(Params[])
		 * @see [String]
		 * @see [URL]
		 * @see [Class name#method name]
		 * @example
		 * @todo
		 * @precondition
		 * @postcondition
		 * @summary
		 * @bug
		 */
		protected void onPreExecute() {

			super.onPreExecute();
			progres = ProgressDialog.show(AulesActivity.this, "Carregant",
					"Obtenint Tutor...");
		}

		@Override
		protected String doInBackground(String... params) {
			String resultat = RESTMethod.Get("/api/v1/user", Applicacio
					.getInstance().getToken());
			Log.v("LOGIN", "JSON RESULTANT USERS:" + resultat);
			return resultat;
		}

		/**
		 * @desc Mtode sobrescrigut de @see
		 *       android.os.AsyncTask#onPostExecute(java.lang.Object)
		 *       <p>
		 * @version: 1.0
		 * @autor: Toms Ruiz
		 * @params:
		 * @return: el valor de
		 * @exception:
		 * @see: @see android.os.AsyncTask#onPostExecute(java.lang.Object)
		 * @see [String]
		 * @see [URL]
		 * @see [Class name#method name]
		 * @example
		 * @todo
		 * @precondition
		 * @postcondition
		 * @summary
		 * @bug
		 */

		@Override
		protected void onPostExecute(String result) {

			Log.v("Usertask.PostExecute1", "parametre entrada" + result);
			super.onPostExecute(result);

			Log.v("Usertask.PostExecute2", "parametre entrada" + result);
			propietari = Tutor.JSONToUser(result);
			progres.dismiss();
			getActionBar().setTitle("Tutor:" + propietari.getName());
			mDrawerTitle = "Tutor:" + propietari.getName();
			Applicacio.getInstance().setPropietari(propietari);
		}

	}

	/**
	 * El Class getUnreadMails.
	 */
	private class getUnreadMails extends AsyncTask<String, Void, Void> {

		/**
		 * Do in background.
		 * 
		 * @param params
		 *            : params
		 * @return void Tipus: AulesActivity
		 * @desc Mtode sobrescrigut de @see
		 *       android.os.AsyncTask#doInBackground(Params[])
		 *       <p>
		 * @version: 1.0
		 * @autor: Toms Ruiz
		 * @params:
		 * @return: el valor de
		 * @exception:
		 * @see: @see android.os.AsyncTask#doInBackground(Params[])
		 * @see [String]
		 * @see [URL]
		 * @see [Class name#method name]
		 * @example
		 * @todo
		 * @precondition
		 * @postcondition
		 * @summary
		 * @bug
		 */

		@Override
		protected Void doInBackground(String... params) {
			String resultat = RESTMethod.Get("/api/v1/mail/messages/unread",
					Applicacio.getInstance().getToken());
			Log.v("LOGIN", "JSON RESULTANT LOGIN:" + resultat);
			JocProves.getInstance().setBustia(
					CorreuElectronicLlista.JSONtoMessagesList(resultat)
							.getMessages());
			Log.v("NOMBRE MAILS UNREAD", "nombre:"
					+ JocProves.getInstance().getBustia().size());
			if (JocProves.getInstance().getBustia().size() > 0) {

			}

			return null;
		}
	}

}