/******************************************************************************************
 * Fitxer:BoardListActivity.java
 * Data Creaci:08-ene-2014
 * Ultima Modificacio: 08-ene-2014
 * Autor:Toms Ruiz
 * Projecte: TUTOC - Aplicaci Android enfocada a la gesti dels tutors a UOC
 * Assignatura:TFC-Desenvolupament aplicacions dispositius mbils (Android) Aula 3
 * Consultor:Joan Vicent  Orenga  Serisuelo
 * Descripci:
 * Log:
 ****************************************************************************************** */
package edu.uoc.tutoc;

import java.util.ArrayList;

import com.google.gson.Gson;

import edu.uoc.tutoc.api.rest.RESTMethod;
import edu.uoc.tutoc.aplicacio.Applicacio;
import edu.uoc.tutoc.aula.Aula;
import edu.uoc.tutoc.taulell.Board;
import edu.uoc.tutoc.taulell.BoardList;
import edu.uoc.tutoc.taulell.adaptadorLlistaTaulells;
import android.os.AsyncTask;
import android.os.Bundle;
import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Intent;
import android.util.Log;
import android.view.Menu;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.AdapterView.OnItemClickListener;

/**
 * El Class BoardListActivity.
 */
public class BoardListActivity extends Activity {

	/** El aula. */
	private Aula aula = new Aula();// Parametre on li pqasarem l'aula que el
									// crida

	/**
	 * @desc Mtode sobrescrigut de @see
	 *       android.app.Activity#onCreate(android.os.Bundle)
	 *       <p>
	 * @version: 1.0
	 * @autor: Toms Ruiz
	 * @params:
	 * @return: el valor de
	 * @exception:
	 * @see: @see android.app.Activity#onCreate(android.os.Bundle)
	 * @see [String]
	 * @see [URL]
	 * @see [Class name#method name]
	 * @example
	 * @todo
	 * @precondition
	 * @postcondition
	 * @summary
	 * @bug
	 */

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.boardlistlayout);
		Bundle bundle = getIntent().getExtras();
		String parametreJSON = bundle.getString("AULA");
		aula = new Gson().fromJson(parametreJSON, Aula.class);
		TextView txtNomAula = (TextView) (findViewById(R.id.activity_carpetes_correus_Carpetes));
		txtNomAula.setText(aula.getTitle());
		getBoards tascaObtenirTaulells = new getBoards();
		tascaObtenirTaulells.execute();

	}

	/**
	 * @desc Mtode sobrescrigut de @see
	 *       android.app.Activity#onCreateOptionsMenu(android.view.Menu)
	 *       <p>
	 * @version: 1.0
	 * @autor: Toms Ruiz
	 * @params:
	 * @return: el valor de
	 * @exception:
	 * @see: @see android.app.Activity#onCreateOptionsMenu(android.view.Menu)
	 * @see [String]
	 * @see [URL]
	 * @see [Class name#method name]
	 * @example
	 * @todo
	 * @precondition
	 * @postcondition
	 * @summary
	 * @bug
	 */

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.board_list, menu);
		return true;
	}

	/**
	 * El Class getBoards.
	 */
	private class getBoards extends AsyncTask<String, Void, String> {

		/** El progres. */
		private ProgressDialog progres;

		/**
		 * Do in background.
		 * 
		 * @param params
		 *            : params
		 * @return string Tipus: BoardListActivity
		 * @desc Mtode sobrescrigut de @see
		 *       android.os.AsyncTask#doInBackground(Params[])
		 *       <p>
		 * @version: 1.0
		 * @autor: Toms Ruiz
		 * @params:
		 * @return: el valor de
		 * @exception:
		 * @see: @see android.os.AsyncTask#doInBackground(Params[])
		 * @see [String]
		 * @see [URL]
		 * @see [Class name#method name]
		 * @example
		 * @todo
		 * @precondition
		 * @postcondition
		 * @summary
		 * @bug
		 */

		@Override
		protected String doInBackground(String... params) {
			String resultat = RESTMethod.Get(
					"/api/v1/classrooms/" + aula.getId() + "/boards",
					Applicacio.getInstance().getToken());
			Log.v("BOARDS", resultat);
			return resultat;
		}

		/**
		 * On post execute.
		 * 
		 * @param result
		 *            : result
		 * @return void
		 * @desc Mtode sobrescrigut de @see
		 *       android.os.AsyncTask#onPostExecute(java.lang.Object)
		 *       <p>
		 * @version: 1.0
		 * @autor: Toms Ruiz
		 * @params:
		 * @return: el valor de
		 * @exception:
		 * @see: @see android.os.AsyncTask#onPostExecute(java.lang.Object)
		 * @see [String]
		 * @see [URL]
		 * @see [Class name#method name]
		 * @example
		 * @todo
		 * @precondition
		 * @postcondition
		 * @summary
		 * @bug
		 */

		@Override
		protected void onPostExecute(String result) {

			super.onPostExecute(result);
			BoardList llistaTaulells = BoardList.JSONtoBoardList(result);
			ArrayList<Board> taulells = llistaTaulells.getBoardList();
			Log.v("Taulells", "mida " + taulells.size());
			ListView ListViewTaulells = (ListView) findViewById(R.id.boardlist_llistataulells);
			ListViewTaulells.setAdapter(new adaptadorLlistaTaulells(
					BoardListActivity.this, taulells));
			ListViewTaulells.setItemsCanFocus(true);
			ListViewTaulells.setOnItemClickListener(new OnItemClickListener() {

				@Override
				public void onItemClick(AdapterView<?> arg0, View arg1,
						int arg2, long arg3) {
					Board taulellSeleccionat = (Board) arg0.getAdapter()
							.getItem(arg2);
					Intent intent = new Intent(BoardListActivity.this,
							FolderBoardList_Activity.class);
					Bundle b = new Bundle();
					String conversioJSON = (new Gson()).toJson(aula);
					b.putString("AULA", conversioJSON);
					intent.putExtras(b);
					conversioJSON = (new Gson()).toJson(taulellSeleccionat);
					b.putString("TAULELL", conversioJSON);
					intent.putExtras(b);
					startActivity(intent);
				}
			});

			progres.dismiss();
		}

		/**
		 * On pre execute.
		 * 
		 * @return void
		 * @desc Mtode sobrescrigut de @see android.os.AsyncTask#onPreExecute()
		 *       <p>
		 * @version: 1.0
		 * @autor: Toms Ruiz
		 * @params:
		 * @return: el valor de
		 * @exception:
		 * @see: @see android.os.AsyncTask#onPreExecute()
		 * @see [String]
		 * @see [URL]
		 * @see [Class name#method name]
		 * @example
		 * @todo
		 * @precondition
		 * @postcondition
		 * @summary
		 * @bug
		 */

		@Override
		protected void onPreExecute() {
			// TODO Desenvolupar funci
			super.onPreExecute();
			progres = ProgressDialog.show(BoardListActivity.this, "Carregant",
					"Carregant-ho...");
		}
	}
}
