/******************************************************************************************
 * Fitxer:BoardMessageDetails.java
 * Data Creaci:08-ene-2014
 * Ultima Modificacio: 08-ene-2014
 * Autor:Toms Ruiz
 * Projecte: TUTOC - Aplicaci Android enfocada a la gesti dels tutors a UOC
 * Assignatura:TFC-Desenvolupament aplicacions dispositius mbils (Android) Aula 3
 * Consultor:Joan Vicent  Orenga  Serisuelo
 * Descripci:
 * Log:
 ****************************************************************************************** */
package edu.uoc.tutoc;

import com.google.gson.Gson;

import edu.uoc.tutoc.taulell.BoardFolderMessage;
import android.os.Bundle;
import android.app.Activity;
import android.content.Intent;
import android.view.Menu;
import android.view.View;
import android.widget.TextView;
import android.widget.Toast;

/**
 * El Class BoardMessageDetails.
 */
public class BoardMessageDetails extends Activity {

	/** El missatge. */
	private BoardFolderMessage missatge = new BoardFolderMessage();

	/**
	 * @desc Mtode sobrescrigut de @see
	 *       android.app.Activity#onCreate(android.os.Bundle)
	 *       <p>
	 * @version: 1.0
	 * @autor: Toms Ruiz
	 * @params:
	 * @return: el valor de
	 * @exception:
	 * @see: @see android.app.Activity#onCreate(android.os.Bundle)
	 * @see [String]
	 * @see [URL]
	 * @see [Class name#method name]
	 * @example
	 * @todo
	 * @precondition
	 * @postcondition
	 * @summary
	 * @bug
	 */

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.boardmessagedetails_layout);
		// Treiem el missatge que ens han passat com parametre a la crida de la
		// classe
		Bundle bundle = getIntent().getExtras();
		String parametreJSON = bundle.getString("MISSATGE");
		missatge = new Gson().fromJson(parametreJSON, BoardFolderMessage.class);
		TextView txtTemp = (TextView) (findViewById(R.id.BoardMessageDetails_txtSubject));
		if (missatge.getSubject() != null) {
			txtTemp.setText(missatge.getSubject());
		}
		if (missatge.getDate() != null) {
			txtTemp = (TextView) (findViewById(R.id.BoardMessageDetails_Data));
			txtTemp.setText(missatge.getDate());
		}
		if (missatge.getFrom() != null) {
			txtTemp = (TextView) (findViewById(R.id.BoardMessageDetails_Autor));
			txtTemp.setText(missatge.getFrom());
		}
		if (missatge.getTo() != null) {
			txtTemp = (TextView) (findViewById(R.id.BoardMessageDetails_Para));
			txtTemp.setText(missatge.getTo());
		}
		if (missatge.getTo() != null) {
			txtTemp = (TextView) (findViewById(R.id.BoardMessageDetails_txtBody));
			txtTemp.setText(missatge.getBody());
		}

	}

	/**
	 * @desc Mtode sobrescrigut de @see
	 *       android.app.Activity#onCreateOptionsMenu(android.view.Menu)
	 *       <p>
	 * @version: 1.0
	 * @autor: Toms Ruiz
	 * @params:
	 * @return: el valor de
	 * @exception:
	 * @see: @see android.app.Activity#onCreateOptionsMenu(android.view.Menu)
	 * @see [String]
	 * @see [URL]
	 * @see [Class name#method name]
	 * @example
	 * @todo
	 * @precondition
	 * @postcondition
	 * @summary
	 * @bug
	 */

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.board_message_details, menu);
		return true;
	}

	/**
	 * On btn esborrar.
	 * 
	 * @param v
	 *            : v
	 * @return void
	 * @desc On btn esborrar.
	 */
	public void onBtnEsborrar(View v) {
		Toast toast1 = Toast.makeText(getApplicationContext(),
				getString(R.string.Err_noAPI), Toast.LENGTH_SHORT);
		toast1.show();
	}

	/**
	 * On btn reply.
	 * 
	 * @param v
	 *            : v
	 * @return void
	 * @desc On btn reply.
	 */
	public void onBtnReply(View v) {
		// TODO: LANZAR LA VISTA ENVIANDO EL CORREO
		Intent intent = new Intent(BoardMessageDetails.this,
				BoardNewMessage.class);
		Bundle b = new Bundle();
		String oldSubject = missatge.getSubject();
		missatge.setSubject("RE:" + oldSubject);
		String aulaJson = (new Gson()).toJson(missatge);
		b.putString("MISSATGE", aulaJson);
		intent.putExtras(b);
		startActivity(intent);

	}
}
