/******************************************************************************************
 * Fitxer:BoardNewMessage.java
 * Data Creaci:08-ene-2014
 * Ultima Modificacio: 08-ene-2014
 * Autor:Toms Ruiz
 * Projecte: TUTOC - Aplicaci Android enfocada a la gesti dels tutors a UOC
 * Assignatura:TFC-Desenvolupament aplicacions dispositius mbils (Android) Aula 3
 * Consultor:Joan Vicent  Orenga  Serisuelo
 * Descripci:
 * Log:
 ****************************************************************************************** */
package edu.uoc.tutoc;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.os.Bundle;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.View;
import android.widget.EditText;

import com.google.gson.Gson;

import edu.uoc.tutoc.taulell.BoardFolderMessage;
import edu.uoc.tutoc.utils.ExceptionTutoc;

/**
 * El Class BoardNewMessage.
 */
public class BoardNewMessage extends Activity {

	/** El missatge. */
	private BoardFolderMessage missatge;

	/**
	 * @desc Mtode sobrescrigut de @see
	 *       android.app.Activity#onCreate(android.os.Bundle)
	 *       <p>
	 * @version: 1.0
	 * @autor: Toms Ruiz
	 * @params:
	 * @return: el valor de
	 * @exception:
	 * @see: @see android.app.Activity#onCreate(android.os.Bundle)
	 * @see [String]
	 * @see [URL]
	 * @see [Class name#method name]
	 * @example
	 * @todo
	 * @precondition
	 * @postcondition
	 * @summary
	 * @bug
	 */

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.boardnewmessage_layout);
		String parametre = getIntent().getExtras().getString("MISSATGE");
		missatge = new Gson().fromJson(parametre, BoardFolderMessage.class);
		EditText editTemp = (EditText) findViewById(R.id.BoardNewMessage_edtSubject);
		editTemp.setText(missatge.getSubject());
		editTemp = (EditText) findViewById(R.id.BoardNewMessage_edtPara);
		editTemp.setText(missatge.getTo());

	}

	/**
	 * @desc Mtode sobrescrigut de @see
	 *       android.app.Activity#onCreateOptionsMenu(android.view.Menu)
	 *       <p>
	 * @version: 1.0
	 * @autor: Toms Ruiz
	 * @params:
	 * @return: el valor de
	 * @exception:
	 * @see: @see android.app.Activity#onCreateOptionsMenu(android.view.Menu)
	 * @see [String]
	 * @see [URL]
	 * @see [Class name#method name]
	 * @example
	 * @todo
	 * @precondition
	 * @postcondition
	 * @summary
	 * @bug
	 */

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.board_new_message, menu);
		return true;
	}

	/**
	 * @desc Mtode sobrescrigut de @see android.app.Activity#onKeyDown(int,
	 *       android.view.KeyEvent)
	 *       <p>
	 * @version: 1.0
	 * @autor: Toms Ruiz
	 * @params:
	 * @return: el valor de
	 * @exception:
	 * @see: @see android.app.Activity#onKeyDown(int, android.view.KeyEvent)
	 * @see [String]
	 * @see [URL]
	 * @see [Class name#method name]
	 * @example
	 * @todo
	 * @precondition
	 * @postcondition
	 * @summary
	 * @bug
	 */

	public boolean onKeyDown(int keyCode, KeyEvent event) {
		if ((keyCode == KeyEvent.KEYCODE_BACK)) {
			finish();
		}
		return super.onKeyDown(keyCode, event);
	}

	/**
	 * On btn cancel.
	 * 
	 * @param v
	 *            : v
	 * @return void
	 * @desc On btn cancel.
	 */
	public void onBtnCancel(View v) {
		finish();
	}

	/**
	 * On btn envia.
	 * 
	 * @param v
	 *            : v
	 * @return void
	 * @throws ExceptionTutoc
	 *             : exception tutoc
	 * @desc On btn envia.
	 */
	public void onBtnEnvia(View v) throws ExceptionTutoc {
		// Mostrem missatge d'enviament
		AlertDialog.Builder missatge_enviament = new AlertDialog.Builder(this);

		missatge_enviament.setTitle(R.string.Missatge_enviamentCorreusTitol);
		missatge_enviament.setMessage(R.string.Missatge_enviamentCorreusMsg);
		missatge_enviament.setPositiveButton(R.string.Global_Yes,
				new DialogInterface.OnClickListener() {

					@Override
					public void onClick(DialogInterface dialog, int which) {

						EditText editTemp = (EditText) findViewById(R.id.BoardNewMessage_edtPara);
						if (editTemp.getText().toString().trim().length() == 0) { // No
																					// hi
																					// ha
																					// destinatari,
																					// no
																					// continuem
							AlertDialog.Builder errormsg = new AlertDialog.Builder(
									BoardNewMessage.this);
							errormsg.setMessage(getString(R.string.Err_MissatgeNouSenseDestinatari));
							errormsg.setTitle("Error");
							errormsg.setPositiveButton("OK", null);
							errormsg.setCancelable(true);
							errormsg.create().show();
							errormsg.setPositiveButton("OK",
									new DialogInterface.OnClickListener() {

										@Override
										public void onClick(
												DialogInterface dialog,
												int which) {
											// Aqui sortim de la funci

										}
									});
							// throw new
							// ExceptionTutoc(getString(R.string.Err_MissatgeNouSenseDestinatari));
						}
						// TODO: Implementar tasca enviament

					}
				});
		missatge_enviament.setNegativeButton(R.string.Global_No,
				new DialogInterface.OnClickListener() {

					@Override
					public void onClick(DialogInterface dialog, int which) {
						dialog.cancel();
					}
				});
		missatge_enviament.create();
		missatge_enviament.show();
	}

}
