/******************************************************************************************
 * Fitxer:Bustia.java
 * Data Creaci:3-dic-2013
 * Ultima Modificacio: 10-dic-2013
 * Autor:Toms Ruiz
 * Projecte: TUTOC - Aplicaci Android enfocada a la gesti dels tutors a UOC
 * Assignatura:TFC-Desenvolupament aplicacions dispositius mbils (Android) Aula 3
 * Consultor:Joan Vicent  Orenga  Serisuelo
 * Descripci:
 * Log:
 ****************************************************************************************** */
package edu.uoc.tutoc;

import java.util.ArrayList;

import com.google.gson.Gson;

import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Intent;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.Toast;
import edu.uoc.tutoc.api.rest.RESTMethod;
import edu.uoc.tutoc.aplicacio.Applicacio;
import edu.uoc.tutoc.bustia.CorreuElectronic;
import edu.uoc.tutoc.bustia.CorreuElectronicLlista;
import edu.uoc.tutoc.bustia.adaptadorLlistaMails;

/**
 * El Class Bustia.
 */
public class Bustia extends Activity {

	/** El url. */
	private String URL;
	private CorreuElectronic missatge = new CorreuElectronic();

	/**
	 * @desc Mtode sobrescrigut de @see
	 *       android.app.Activity#onCreate(android.os.Bundle)
	 *       <p>
	 * @version: 1.0
	 * @autor: Toms Ruiz
	 * @params:
	 * @return: el valor de
	 * @exception:
	 * @see: @see android.app.Activity#onCreate(android.os.Bundle)
	 * @see [String]
	 * @see [URL]
	 * @see [Class name#method name]
	 * @example
	 * @todo
	 * @precondition
	 * @postcondition
	 * @summary
	 * @bug
	 */

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_bustia);
		String parametre = getIntent().getExtras().getString("URLAPI");
		Log.v("URLAPI", parametre);
		URL = parametre;
		Toast.makeText(this, parametre, Toast.LENGTH_SHORT).show();
		getMailsfromFolderTask tascaAPI = new getMailsfromFolderTask(parametre);
		tascaAPI.execute();

	}

	/**
	 * @desc Mtode sobrescrigut de @see
	 *       android.app.Activity#onCreateOptionsMenu(android.view.Menu)
	 *       <p>
	 * @version: 1.0
	 * @autor: Toms Ruiz
	 * @params:
	 * @return: el valor de
	 * @exception:
	 * @see: @see android.app.Activity#onCreateOptionsMenu(android.view.Menu)
	 * @see [String]
	 * @see [URL]
	 * @see [Class name#method name]
	 * @example
	 * @todo
	 * @precondition
	 * @postcondition
	 * @summary
	 * @bug
	 */

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.bustia, menu);
		return true;
	}

	public void oneventNewMail(View v) {
		if (Applicacio.getInstance().getToken() != null) {
			CorreuElectronic missatgenou = new CorreuElectronic();
			Intent intent = new Intent(Bustia.this, MailNewMessage.class);
			Bundle b = new Bundle();
			String aulaJson = (new Gson()).toJson(missatgenou);
			b.putString("MISSATGE", aulaJson);
			intent.putExtras(b);
			startActivity(intent);
		} else {
			Toast toast1 = Toast.makeText(getApplicationContext(),
					getString(R.string.Err_necessariConnectar),
					Toast.LENGTH_SHORT);
			toast1.show();
		}

	}

	/**
	 * Event cerca.
	 * 
	 * @param v
	 *            : v
	 * @return void
	 * @desc Event cerca.
	 */
	public void eventCerca(View v) {
		String criteri = ((EditText) findViewById(R.id.txtCriteri)).getText()
				.toString();
		getMailsfromFolderTask tasca = new getMailsfromFolderTask(this.URL
				+ "?q=" + criteri);
		tasca.execute();
	}

	/**
	 * Retorna el missatge
	 * <p>
	 * Aquest mtode retornar missatge
	 * 
	 * @param:
	 * @return: missatge tipus: CorreuElectronic
	 * @see:#missatge
	 * @throws:
	 */
	public CorreuElectronic getMissatge() {
		return missatge; // Es retorna missatge

	}

	/**
	 * Dna Valor al missatge
	 * <p>
	 * Posa com valor de missatge el missatge
	 * 
	 * @param:missatge Tipus: CorreuElectronic
	 * @return: void
	 * @see:#missatge
	 * @throws:
	 */
	public void setMissatge(CorreuElectronic missatge) {
		this.missatge = missatge; // Se assigna el valor

	}

	/**
	 * El Class getMailsfromFolderTask.
	 */
	private class getMailsfromFolderTask extends
			AsyncTask<String, Void, String> {

		/** El url. */
		private String URL;

		/** El progres. */
		private ProgressDialog progres;

		/**
		 * Defineix el url.
		 * 
		 * @param url
		 *            el nou url de tipus void
		 * @desc Dona valor url.
		 */
		private void setURL(String url) {
			this.URL = url;
		}

		/**
		 * The Constructor.
		 * 
		 * @param URL
		 *            : url
		 * @desc: Instancia una nova obt el mailsfrom folder task. esttica:
		 *        false
		 * @date: 10-dic-2013 21:28:55 package: edu.uoc.tutoc
		 */
		public getMailsfromFolderTask(String URL) {
			this.setURL(URL);
		}

		/**
		 * @desc Mtode sobrescrigut de @see
		 *       android.os.AsyncTask#doInBackground(Params[])
		 *       <p>
		 * @version: 1.0
		 * @autor: Toms Ruiz
		 * @params:
		 * @return: el valor de
		 * @exception:
		 * @see: @see android.os.AsyncTask#doInBackground(Params[])
		 * @see [String]
		 * @see [URL]
		 * @see [Class name#method name]
		 * @example
		 * @todo
		 * @precondition
		 * @postcondition
		 * @summary
		 * @bug
		 */

		@Override
		protected String doInBackground(String... params) {
			String resultat = RESTMethod.Get(this.URL, Applicacio.getInstance()
					.getToken());
			Log.v("LOGIN", "JSON RESULTANT LOGIN:" + resultat);

			return resultat;
		}

		/**
		 * On post execute.
		 * 
		 * @param result
		 *            : result
		 * @return void
		 * @desc Mtode sobrescrigut de @see
		 *       android.os.AsyncTask#onPostExecute(java.lang.Object)
		 *       <p>
		 * @version: 1.0
		 * @autor: Toms Ruiz
		 * @params:
		 * @return: el valor de
		 * @exception:
		 * @see: @see android.os.AsyncTask#onPostExecute(java.lang.Object)
		 * @see [String]
		 * @see [URL]
		 * @see [Class name#method name]
		 * @example
		 * @todo
		 * @precondition
		 * @postcondition
		 * @summary
		 * @bug
		 */

		@Override
		protected void onPostExecute(String result) {
			// TODO Desenvolupar funci
			super.onPostExecute(result);
			ArrayList<CorreuElectronic> bustia = CorreuElectronicLlista
					.JSONtoMessagesList(result).getMessages();
			ListView llistaMails = (ListView) findViewById(R.id.activityAules_llistaAules);
			llistaMails
					.setAdapter(new adaptadorLlistaMails(Bustia.this, bustia));
			llistaMails.setItemsCanFocus(true);
			llistaMails.setOnItemClickListener(new OnItemClickListener() {

				@Override
				public void onItemClick(AdapterView<?> arg0, View arg1,
						int arg2, long arg3) {
					Log.v("Bustia", "Click en una bustia");
					CorreuElectronic correuSeleccionat = (CorreuElectronic) arg0
							.getAdapter().getItem(arg2);
					Intent intent = new Intent(Bustia.this,
							MailMessageDetail.class);
					Bundle b = new Bundle();
					String conversioJSON = (new Gson())
							.toJson(correuSeleccionat);
					b.putString("MISSATGE", conversioJSON);
					intent.putExtras(b);
					startActivity(intent);

				}
			});
			progres.dismiss();
		}

		/**
		 * On pre execute.
		 * 
		 * @return void
		 * @desc Mtode sobrescrigut de @see android.os.AsyncTask#onPreExecute()
		 *       <p>
		 * @version: 1.0
		 * @autor: Toms Ruiz
		 * @params:
		 * @return: el valor de
		 * @exception:
		 * @see: @see android.os.AsyncTask#onPreExecute()
		 * @see [String]
		 * @see [URL]
		 * @see [Class name#method name]
		 * @example
		 * @todo
		 * @precondition
		 * @postcondition
		 * @summary
		 * @bug
		 */

		@Override
		protected void onPreExecute() {

			super.onPreExecute();
			progres = ProgressDialog.show(Bustia.this, "Carregant",
					"Carregant-ho...");
		}
	}
}
