/******************************************************************************************
 * Fitxer:CarpetesCorreus.java
 * Data Creaci:20-nov-2013
 * Ultima Modificacio: 10-dic-2013
 * Autor:Toms Ruiz
 * Projecte: TUTOC - Aplicaci Android enfocada a la gesti dels tutors a UOC
 * Assignatura:TFC-Desenvolupament aplicacions dispositius mbils (Android) Aula 3
 * Consultor:Joan Vicent  Orenga  Serisuelo
 * Descripci:
 * Log:
 ****************************************************************************************** */
package edu.uoc.tutoc;

import java.util.ArrayList;
import android.app.Activity;
import android.content.Intent;
import android.content.res.Configuration;
import android.os.Bundle;
import android.support.v4.app.ActionBarDrawerToggle;
import android.support.v4.widget.DrawerLayout;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ListView;

import edu.uoc.tutoc.bustia.AdaptadorLlistaCarpetaCorreus;
import edu.uoc.tutoc.bustia.CorreuElectronicCarpeta;
import edu.uoc.tutoc.test.JocProves;

/**
 * El Class CarpetesCorreus.
 */
public class CarpetesCorreus extends Activity {
	private DrawerLayout mDrawerLayout;
	private ListView mDrawerList;
	private ActionBarDrawerToggle mDrawerToggle;

	private CharSequence mDrawerTitle;
	private CharSequence mTitle;
	private String[] mOpcionesMenu;

	/**
	 * @desc Mtode sobrescrigut de @see
	 *       android.app.Activity#onCreate(android.os.Bundle)
	 *       <p>
	 * @version: 1.0
	 * @autor: Toms Ruiz
	 * @params:
	 * @return: el valor de
	 * @exception:
	 * @see: @see android.app.Activity#onCreate(android.os.Bundle)
	 * @see [String]
	 * @see [URL]
	 * @see [Class name#method name]
	 * @example
	 * @todo
	 * @precondition
	 * @postcondition
	 * @summary
	 * @bug
	 */

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_carpetes_correus);
		// MDRAWER

		Log.v("AULES", "Iniciem la detecci de carpetes");
		mTitle = mDrawerTitle = getTitle();
		mOpcionesMenu = new String[] { "AULES", "SORTIR" };

		mDrawerLayout = (DrawerLayout) findViewById(R.id.drawer_layout);
		mDrawerList = (ListView) findViewById(R.id.left_drawer);
		mDrawerList.setAdapter(new ArrayAdapter<String>(this,
				R.layout.drawer_item, mOpcionesMenu));
		mDrawerList.setOnItemClickListener(new DrawerItemClickListener());

		getActionBar().setDisplayHomeAsUpEnabled(true); // Per habilitar la
														// barra d'eines

		mDrawerToggle = new ActionBarDrawerToggle(this, mDrawerLayout,
				R.drawable.ic_drawer, R.string.drawer_open,
				R.string.drawer_close) {
			public void onDrawerClosed(View view) {
				getActionBar().setTitle(mTitle);
				invalidateOptionsMenu();
			}

			public void onDrawerOpened(View drawerView) {
				getActionBar().setTitle(mDrawerTitle);
				invalidateOptionsMenu();
			}
		};
		mDrawerLayout.setDrawerListener(mDrawerToggle);

		// MDRAWER

		ArrayList<CorreuElectronicCarpeta> carpetes = JocProves.getInstance()
				.getCarpetes();
		Log.v("Carpetes Correus", "Mida carpetes:" + carpetes.size());
		ListView llistaCarpetesCorreus = (ListView) findViewById(R.id.activityCarpetaCorreusLlistaCarpetes);
		llistaCarpetesCorreus.setAdapter(new AdaptadorLlistaCarpetaCorreus(
				this, carpetes));
		llistaCarpetesCorreus.setItemsCanFocus(true);
		// Activem el event click
		llistaCarpetesCorreus.setOnItemClickListener(new OnItemClickListener() {

			@Override
			public void onItemClick(AdapterView<?> arg0, View arg1, int arg2,
					long arg3) {
				Log.v("Bustia", "Click en una bustia");
				CorreuElectronicCarpeta carpeta = (CorreuElectronicCarpeta) arg0
						.getAdapter().getItem(arg2);
				Intent intent = new Intent(CarpetesCorreus.this, Bustia.class);
				Bundle b = new Bundle();
				String URLAPI = "/api/v1/mail/folders/" + carpeta.getId()
						+ "/messages";
				b.putString("URLAPI", URLAPI);
				intent.putExtras(b);
				startActivity(intent);

			}
		});
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		if (mDrawerToggle.onOptionsItemSelected(item)) {
			return true;
		} else {
			return super.onOptionsItemSelected(item);
		}
	}

	@Override
	public void setTitle(CharSequence title) {
		mTitle = title;
		getActionBar().setTitle(mTitle);
	}

	@Override
	protected void onPostCreate(Bundle savedInstanceState) {
		super.onPostCreate(savedInstanceState);
		mDrawerToggle.syncState();
	}

	@Override
	public void onConfigurationChanged(Configuration newConfig) {
		super.onConfigurationChanged(newConfig);
		mDrawerToggle.onConfigurationChanged(newConfig);
	}

	/**
	 * @desc Mtode sobrescrigut de @see
	 *       android.app.Activity#onCreateOptionsMenu(android.view.Menu)
	 *       <p>
	 * @version: 1.0
	 * @autor: Toms Ruiz
	 * @params:
	 * @return: el valor de
	 * @exception:
	 * @see: @see android.app.Activity#onCreateOptionsMenu(android.view.Menu)
	 * @see [String]
	 * @see [URL]
	 * @see [Class name#method name]
	 * @example
	 * @todo
	 * @precondition
	 * @postcondition
	 * @summary
	 * @bug
	 */

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.carpetes_correus, menu);
		return true;
	}

	private class DrawerItemClickListener implements
			ListView.OnItemClickListener {
		@Override
		public void onItemClick(AdapterView<?> parent, View view, int position,
				long id) {
			selectItem(position);
			mDrawerLayout.closeDrawer(mDrawerList);
		}

	}

	/**
	 * DrawerItemClickListener.selectItem
	 * 
	 * @desc <p>
	 * @version: 1.0 - 02/01/2014
	 * @autor: Toms Ruiz
	 * @params:
	 * @return: el valor de Tipus: void
	 * @exception:
	 * @see: selectItem, DrawerItemClickListener * @see [String]
	 * @see [URL]
	 * @see [Class name#method name]
	 * @example
	 * @todo
	 * @precondition
	 * @postcondition
	 * @summary
	 * @bug
	 */

	private void selectItem(int position) {
		// TODO Desenvolupar funci
		switch (position) {
		case 0:
			startActivity(new Intent(this, AulesActivity.class));
			finish();
			break;
		case 1:
			finish();
			break;
		default:
			break;
		}
	}
}
