/******************************************************************************************
 * Fitxer:FolderBoardList_Activity.java
 * Data Creaci:08-ene-2014
 * Ultima Modificacio: 08-ene-2014
 * Autor:Toms Ruiz
 * Projecte: TUTOC - Aplicaci Android enfocada a la gesti dels tutors a UOC
 * Assignatura:TFC-Desenvolupament aplicacions dispositius mbils (Android) Aula 3
 * Consultor:Joan Vicent  Orenga  Serisuelo
 * Descripci:
 * Log:
 ****************************************************************************************** */
package edu.uoc.tutoc;

import java.util.ArrayList;

import com.google.gson.Gson;

import edu.uoc.tutoc.api.rest.RESTMethod;
import edu.uoc.tutoc.aplicacio.Applicacio;
import edu.uoc.tutoc.aula.Aula;
import edu.uoc.tutoc.taulell.Board;
import edu.uoc.tutoc.taulell.BoardFolder;
import edu.uoc.tutoc.taulell.BoardFolderList;
import edu.uoc.tutoc.taulell.adaptadorLlistaCarpetesTaulells;
import android.os.AsyncTask;
import android.os.Bundle;
import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Intent;
import android.util.Log;
import android.view.Menu;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ListView;
import android.widget.TextView;

/**
 * El Class FolderBoardList_Activity.
 */
public class FolderBoardList_Activity extends Activity {

	/** El taulell. */
	private Board taulell = new Board();

	/** El aula. */
	private Aula aula = new Aula();

	/**
	 * @desc Mtode sobrescrigut de @see
	 *       android.app.Activity#onCreate(android.os.Bundle)
	 *       <p>
	 * @version: 1.0
	 * @autor: Toms Ruiz
	 * @params:
	 * @return: el valor de
	 * @exception:
	 * @see: @see android.app.Activity#onCreate(android.os.Bundle)
	 * @see [String]
	 * @see [URL]
	 * @see [Class name#method name]
	 * @example
	 * @todo
	 * @precondition
	 * @postcondition
	 * @summary
	 * @bug
	 */

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.folderboardlist_layout);
		taulell = new Board();
		aula = new Aula();
		Bundle bundle = getIntent().getExtras();
		String parametreJSON = bundle.getString("TAULELL");
		taulell = new Gson().fromJson(parametreJSON, Board.class);
		parametreJSON = bundle.getString("AULA");
		aula = new Gson().fromJson(parametreJSON, Aula.class);
		TextView nomTaulell = (TextView) (findViewById(R.id.folderboardlisttxtNomTaulell));
		nomTaulell.setText("Taulell: " + taulell.getTitle());
		TextView nomAula = (TextView) (findViewById(R.id.folderboardlisttxtNomAula));
		nomAula.setText("Aula:" + aula.getTitle());
		getBoardFolders tascaAPI = new getBoardFolders();
		tascaAPI.execute();
	}

	/**
	 * @desc Mtode sobrescrigut de @see
	 *       android.app.Activity#onCreateOptionsMenu(android.view.Menu)
	 *       <p>
	 * @version: 1.0
	 * @autor: Toms Ruiz
	 * @params:
	 * @return: el valor de
	 * @exception:
	 * @see: @see android.app.Activity#onCreateOptionsMenu(android.view.Menu)
	 * @see [String]
	 * @see [URL]
	 * @see [Class name#method name]
	 * @example
	 * @todo
	 * @precondition
	 * @postcondition
	 * @summary
	 * @bug
	 */

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.folder_board_list_, menu);
		return true;
	}

	/**
	 * El Class getBoardFolders.
	 */
	private class getBoardFolders extends AsyncTask<String, Void, String> {

		/** El progres. */
		private ProgressDialog progres;

		/**
		 * Do in background.
		 * 
		 * @param params
		 *            : params
		 * @return string Tipus: FolderBoardList_Activity
		 * @desc Mtode sobrescrigut de @see
		 *       android.os.AsyncTask#doInBackground(Params[])
		 *       <p>
		 * @version: 1.0
		 * @autor: Toms Ruiz
		 * @params:
		 * @return: el valor de
		 * @exception:
		 * @see: @see android.os.AsyncTask#doInBackground(Params[])
		 * @see [String]
		 * @see [URL]
		 * @see [Class name#method name]
		 * @example
		 * @todo
		 * @precondition
		 * @postcondition
		 * @summary
		 * @bug
		 */

		@Override
		protected String doInBackground(String... params) {
			String resultat = RESTMethod.Get(
					"/api/v1/classrooms/" + aula.getId() + "/boards/"
							+ taulell.getId() + "/folders", Applicacio
							.getInstance().getToken());
			Log.v("LOGIN", "JSON RESULTANT LOGIN:" + resultat);
			return resultat;

		}

		/**
		 * On post execute.
		 * 
		 * @param result
		 *            : result
		 * @return void
		 * @desc Mtode sobrescrigut de @see
		 *       android.os.AsyncTask#onPostExecute(java.lang.Object)
		 *       <p>
		 * @version: 1.0
		 * @autor: Toms Ruiz
		 * @params:
		 * @return: el valor de
		 * @exception:
		 * @see: @see android.os.AsyncTask#onPostExecute(java.lang.Object)
		 * @see [String]
		 * @see [URL]
		 * @see [Class name#method name]
		 * @example
		 * @todo
		 * @precondition
		 * @postcondition
		 * @summary
		 * @bug
		 */

		@Override
		protected void onPostExecute(String result) {

			super.onPostExecute(result);
			BoardFolderList llistaCarpetesTaulell = BoardFolderList
					.JSONtoFolderList(result);
			ArrayList<BoardFolder> carpetesTaulell = llistaCarpetesTaulell
					.getFolders();
			Log.v("BoardFolders", "mida:" + carpetesTaulell.size());
			ListView lstCarpetesTaulell = (ListView) findViewById(R.id.folderboardlistListViewllistaCarpetes);
			lstCarpetesTaulell.setAdapter(new adaptadorLlistaCarpetesTaulells(
					FolderBoardList_Activity.this, carpetesTaulell));
			lstCarpetesTaulell.setItemsCanFocus(true);
			lstCarpetesTaulell
					.setOnItemClickListener(new OnItemClickListener() {

						@Override
						public void onItemClick(AdapterView<?> arg0, View arg1,
								int arg2, long arg3) {
							BoardFolder carpetaTaulellSeleccionat = (BoardFolder) arg0
									.getAdapter().getItem(arg2);
							Intent intent = new Intent(
									FolderBoardList_Activity.this,
									MesaggesFolderBoard_activity.class);
							Bundle b = new Bundle();
							String conversioJSON = (new Gson()).toJson(aula);
							b.putString("AULA", conversioJSON);
							intent.putExtras(b);
							conversioJSON = (new Gson()).toJson(taulell);
							b.putString("TAULELL", conversioJSON);
							intent.putExtras(b);
							conversioJSON = (new Gson())
									.toJson(carpetaTaulellSeleccionat);
							b.putString("CARPETA", conversioJSON);
							intent.putExtras(b);
							startActivity(intent);
						}

					});
			progres.dismiss();
		}

		/**
		 * On pre execute.
		 * 
		 * @return void
		 * @desc Mtode sobrescrigut de @see android.os.AsyncTask#onPreExecute()
		 *       <p>
		 * @version: 1.0
		 * @autor: Toms Ruiz
		 * @params:
		 * @return: el valor de
		 * @exception:
		 * @see: @see android.os.AsyncTask#onPreExecute()
		 * @see [String]
		 * @see [URL]
		 * @see [Class name#method name]
		 * @example
		 * @todo
		 * @precondition
		 * @postcondition
		 * @summary
		 * @bug
		 */

		@Override
		protected void onPreExecute() {
			// TODO Desenvolupar funci
			super.onPreExecute();
			progres = ProgressDialog.show(FolderBoardList_Activity.this,
					"Carregant", "Carregant-ho...");
		}
	}
}
