/******************************************************************************************
 * Fitxer:LoginActivity.java
 * Data Creaci:10-nov-2013
 * Ultima Modificacio: 10-dic-2013
 * Autor:Toms Ruiz
 * Projecte: TUTOC - Aplicaci Android enfocada a la gesti dels tutors a UOC
 * Assignatura:TFC-Desenvolupament aplicacions dispositius mbils (Android) Aula 3
 * Consultor:Joan Vicent  Orenga  Serisuelo
 * Descripci:
 * Log:
 ****************************************************************************************** */
package edu.uoc.tutoc;

import org.apache.amber.oauth2.client.OAuthClient;
import org.apache.amber.oauth2.client.URLConnectionClient;
import org.apache.amber.oauth2.client.request.OAuthClientRequest;
import org.apache.amber.oauth2.client.response.OAuthJSONAccessTokenResponse;
import org.apache.amber.oauth2.common.exception.OAuthProblemException;
import org.apache.amber.oauth2.common.exception.OAuthSystemException;
import org.apache.amber.oauth2.common.message.types.GrantType;

import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Intent;
import android.net.Uri;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.Log;
import android.widget.Toast;
import edu.uoc.tutoc.aplicacio.Applicacio;
import edu.uoc.tutoc.utils.Constant;

/**
 * El Class LoginActivity.
 */
public class IdentificacioActivity extends Activity {
	private ProgressDialog progressDialog;
	/** El oauth token. */
	private String oauthToken;

	/** El expire token. */
	Long expireToken;

	/** El running. */
	public boolean running;

	/**
	 * @desc Mtode sobrescrigut de @see
	 *       android.app.Activity#onCreate(android.os.Bundle)
	 *       <p>
	 * @version: 1.0
	 * @autor: Toms Ruiz
	 * @params:
	 * @return: el valor de
	 * @exception:
	 * @see: @see android.app.Activity#onCreate(android.os.Bundle)
	 * @see [String]
	 * @see [URL]
	 * @see [Class name#method name]
	 * @example
	 * @todo
	 * @precondition
	 * @postcondition
	 * @summary
	 * @bug
	 */

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_login);
		// Mostrem progress dialog
		progressDialog = new ProgressDialog(this);
		progressDialog.setCancelable(false);
		progressDialog.setIndeterminate(true);
		progressDialog.setTitle(getResources().getString(
				R.string.Global_Carregant));
		progressDialog.setMessage(getResources().getString(
				R.string.msg_identificacio));
		this.IniciarLogin();
	}

	/**
	 * @desc Mtode sobrescrigut de @see android.app.Activity#onStart()
	 *       <p>
	 * @version: 1.0
	 * @autor: Toms Ruiz
	 * @params:
	 * @return: el valor de
	 * @exception:
	 * @see: @see android.app.Activity#onStart()
	 * @see [String]
	 * @see [URL]
	 * @see [Class name#method name]
	 * @example
	 * @todo
	 * @precondition
	 * @postcondition
	 * @summary
	 * @bug
	 */

	@Override
	protected void onStart() {
		super.onStart();

	}

	/**
	 * @desc Mtode sobrescrigut de @see android.app.Activity#onResume()
	 *       <p>
	 * @version: 1.0
	 * @autor: Toms Ruiz
	 * @params:
	 * @return: el valor de
	 * @exception:
	 * @see: @see android.app.Activity#onResume()
	 * @see [String]
	 * @see [URL]
	 * @see [Class name#method name]
	 * @example
	 * @todo
	 * @precondition
	 * @postcondition
	 * @summary
	 * @bug
	 */

	@Override
	protected void onResume() {
		super.onResume();
	}

	/**
	 * Iniciar login.
	 * 
	 * @return void
	 * @desc Iniciar login.
	 */
	public void IniciarLogin() {

		OAuthClientRequest request = null;
		try {

			request = OAuthClientRequest
					.authorizationLocation(Constant.AUTHORIZE_URI)
					.setClientId(Constant.CLIENT).setScope(Constant.SCOPE)
					.setRedirectURI(Constant.REDIRECT_URI).buildQueryMessage();

		} catch (OAuthSystemException e) {
			Log.e("Iniciar Login", "EError al fer request");
			e.printStackTrace();
		}

		Intent intent = new Intent(Intent.ACTION_VIEW, Uri.parse(request
				.getLocationUri() + "&response_type=code"))
				.setFlags(Intent.FLAG_ACTIVITY_CLEAR_TASK
						| Intent.FLAG_ACTIVITY_NEW_TASK);

		Log.v("navegador", "Iniciar browser");
		startActivity(intent); // Iniciamos navegador

	}

	/**
	 * @desc Mtode sobrescrigut de @see
	 *       android.app.Activity#onNewIntent(android.content.Intent)
	 *       <p>
	 * @version: 1.0
	 * @autor: Toms Ruiz
	 * @params:
	 * @return: el valor de
	 * @exception:
	 * @see: @see android.app.Activity#onNewIntent(android.content.Intent)
	 * @see [String]
	 * @see [URL]
	 * @see [Class name#method name]
	 * @example
	 * @todo
	 * @precondition
	 * @postcondition
	 * @summary
	 * @bug
	 */

	protected void onNewIntent(Intent intent) {
		super.onNewIntent(intent);
		Log.v("onNewIntent", "uri " + intent.getData());
		Uri uri = intent.getData();
		if (uri != null && uri.toString().startsWith(Constant.REDIRECT_URI)) {
			String code = uri.getQueryParameter("code");
			Log.i("LOGIN", "codi: " + code);
			new getTokenTask().execute(code);
			progressDialog.show();
		}

	}

	/**
	 * El Class getTokenTask.
	 */
	private class getTokenTask extends AsyncTask<String, Void, String> {// Hem
																		// de
																		// fer
																		// AsyncTask
																		// perque
																		// si
																		// fem
																		// una
																		// connexi
																		// per
																		// Internet
																		// no
																		// bloquejarem
																		// la
																		// nostra
																		// aplicaci

		/**
		 * @desc Mtode sobrescrigut de @see android.os.AsyncTask#onPreExecute()
		 *       <p>
		 * @version: 1.0
		 * @autor: Toms Ruiz
		 * @params:
		 * @return: el valor de
		 * @exception:
		 * @see: @see android.os.AsyncTask#onPreExecute()
		 * @see [String]
		 * @see [URL]
		 * @see [Class name#method name]
		 * @example
		 * @todo
		 * @precondition
		 * @postcondition
		 * @summary
		 * @bug
		 */

		@Override
		protected void onPreExecute() {
			running = true;
			super.onPreExecute();
		}

		/**
		 * @desc Mtode sobrescrigut de @see
		 *       android.os.AsyncTask#onPostExecute(java.lang.Object)
		 *       <p>
		 * @version: 1.0
		 * @autor: Toms Ruiz
		 * @params:
		 * @return: el valor de
		 * @exception:
		 * @see: @see android.os.AsyncTask#onPostExecute(java.lang.Object)
		 * @see [String]
		 * @see [URL]
		 * @see [Class name#method name]
		 * @example
		 * @todo
		 * @precondition
		 * @postcondition
		 * @summary
		 * @bug
		 */

		protected void onPostExecute(String result) {
			oauthToken = result;
			progressDialog.dismiss();
			if (oauthToken == null) {
				Toast.makeText(getApplicationContext(),
						"Error d'identificaci", Toast.LENGTH_LONG).show();
				finish();
			} else {
				Toast.makeText(getApplicationContext(),
						"Usuari identificat correctament", Toast.LENGTH_LONG)
						.show();
				Log.i("TOKEN OK",
						"Usuari identificat de manera correcta al campus extern");
				Log.v("ASYNC", "Token obtenido en asyncTask: " + result);
				Applicacio.getInstance().setToken(result);
				startActivity(new Intent(IdentificacioActivity.this,
						AulesActivity.class));
				finish();
			}

		}

		/**
		 * @desc Mtode sobrescrigut de @see
		 *       android.os.AsyncTask#doInBackground(Params[])
		 *       <p>
		 * @version: 1.0
		 * @autor: Toms Ruiz
		 * @params:
		 * @return: el valor de
		 * @exception:
		 * @see: @see android.os.AsyncTask#doInBackground(Params[])
		 * @see [String]
		 * @see [URL]
		 * @see [Class name#method name]
		 * @example
		 * @todo
		 * @precondition
		 * @postcondition
		 * @summary
		 * @bug
		 */

		@Override
		protected String doInBackground(String... code) {
			oauthToken = retriveAccesToken(Constant.CLIENT, Constant.SECRET,
					Constant.REDIRECT_URI, code[0]);
			return oauthToken;

		}
	}

	/**
	 * Retrive acces token.
	 * 
	 * @param client
	 *            : client
	 * @param secret
	 *            : secret
	 * @param redirectUri
	 *            : redirect uri
	 * @param code
	 *            : code
	 * @return string Tipus: LoginActivity
	 */
	private String retriveAccesToken(String client, String secret,
			String redirectUri, String code) {
		OAuthClientRequest request = null;

		try {
			request = OAuthClientRequest
					.tokenLocation(Constant.ACCES_TOKEN_URI)
					.setGrantType(GrantType.AUTHORIZATION_CODE)
					.setClientId(client).setClientSecret(secret)
					.setRedirectURI(redirectUri).setCode(code)
					.buildBodyMessage();
		} catch (OAuthSystemException e) {
			Log.e("LOGIN_ERROR", "Error Intern");
			e.printStackTrace();
			return null;
		}

		try {
			OAuthClient oAuthClient = new OAuthClient(new URLConnectionClient());
			OAuthJSONAccessTokenResponse response;
			response = oAuthClient.accessToken(request);
			oauthToken = response.getAccessToken();
			expireToken = response.getExpiresIn();
			response.getRefreshToken();
			Log.v("LOGIN", response.getBody().toString());
			return oauthToken;

		} catch (OAuthSystemException e1) {
			Log.e("LOGIN_ERROR", "Error Intern");
			e1.printStackTrace();
			return null;
		} catch (OAuthProblemException e1) {
			Log.e("LOGIN_ERROR", "Error Intern: AccessToken");
			//
			e1.printStackTrace();
			return null;
		}
	}
}
