/******************************************************************************************
 * Fitxer:MesaggesFolderBoard_activity.java
 * Data Creaci:08-ene-2014
 * Ultima Modificacio: 08-ene-2014
 * Autor:Toms Ruiz
 * Projecte: TUTOC - Aplicaci Android enfocada a la gesti dels tutors a UOC
 * Assignatura:TFC-Desenvolupament aplicacions dispositius mbils (Android) Aula 3
 * Consultor:Joan Vicent  Orenga  Serisuelo
 * Descripci:
 * Log:
 ****************************************************************************************** */
package edu.uoc.tutoc;

import java.util.ArrayList;

import com.google.gson.Gson;

import edu.uoc.tutoc.api.rest.RESTMethod;
import edu.uoc.tutoc.aplicacio.Applicacio;
import edu.uoc.tutoc.aula.Aula;
import edu.uoc.tutoc.taulell.Board;
import edu.uoc.tutoc.taulell.BoardFolder;
import edu.uoc.tutoc.taulell.BoardFolderMessage;
import edu.uoc.tutoc.taulell.BoardFolderMessageList;
import edu.uoc.tutoc.taulell.adaptadorLlistaMissatgesCarpetesTaulell;
import android.os.AsyncTask;
import android.os.Bundle;
import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Intent;
import android.util.Log;
import android.view.Menu;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ListView;

public class MesaggesFolderBoard_activity extends Activity {
	private BoardFolderMessage missatge = new BoardFolderMessage();
	private Board taulell = new Board();
	private Aula aula = new Aula();
	private BoardFolder carpetaTaulell = new BoardFolder();

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_mesagges_folder_board_activity);
		Bundle bundle = getIntent().getExtras();
		String parametreJSON = bundle.getString("TAULELL");
		taulell = new Gson().fromJson(parametreJSON, Board.class);
		parametreJSON = bundle.getString("AULA");
		aula = new Gson().fromJson(parametreJSON, Aula.class);
		parametreJSON = bundle.getString("CARPETA");
		carpetaTaulell = new Gson().fromJson(parametreJSON, BoardFolder.class);
		getBoardMessages tascaAPI = new getBoardMessages();
		tascaAPI.execute();
	}

	public void oneventNewPost(View V) {
		Intent intent = new Intent(MesaggesFolderBoard_activity.this,
				BoardNewMessage.class);
		Bundle b = new Bundle();
		String aulaJson = (new Gson()).toJson(missatge);
		b.putString("MISSATGE", aulaJson);
		intent.putExtras(b);
		startActivity(intent);
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.mesagges_folder_board_activity, menu);

		return true;
	}

	private class getBoardMessages extends AsyncTask<String, Void, String> {
		private ProgressDialog progres;

		/**
		 * Do in background.
		 * 
		 * @param params
		 *            : params
		 * @return string Tipus: MesaggesFolderBoard_activity
		 * @desc Mtode sobrescrigut de @see
		 *       android.os.AsyncTask#doInBackground(Params[])
		 *       <p>
		 * @version: 1.0
		 * @autor: Toms Ruiz
		 * @params:
		 * @return: el valor de
		 * @exception:
		 * @see: @see android.os.AsyncTask#doInBackground(Params[])
		 * @see [String]
		 * @see [URL]
		 * @see [Class name#method name]
		 * @example
		 * @todo
		 * @precondition
		 * @postcondition
		 * @summary
		 * @bug
		 */

		@Override
		protected String doInBackground(String... params) {
			String resultat = RESTMethod.Get(
					"/api/v1/classrooms/" + aula.getId() + "/boards/"
							+ taulell.getId() + "/folders/"
							+ carpetaTaulell.getId() + "/messages", Applicacio
							.getInstance().getToken());
			Log.v("LOGIN", "JSON RESULTANT LOGIN:" + resultat);
			return resultat;
		}

		/**
		 * @desc Mtode sobrescrigut de @see
		 *       android.os.AsyncTask#onPostExecute(java.lang.Object)
		 *       <p>
		 * @version: 1.0
		 * @autor: Toms Ruiz
		 * @params:
		 * @return: el valor de
		 * @exception:
		 * @see: @see android.os.AsyncTask#onPostExecute(java.lang.Object)
		 * @see [String]
		 * @see [URL]
		 * @see [Class name#method name]
		 * @example
		 * @todo
		 * @precondition
		 * @postcondition
		 * @summary
		 * @bug
		 */

		@Override
		protected void onPostExecute(String result) {
			// TODO Desenvolupar funci
			super.onPostExecute(result);
			BoardFolderMessageList llistaMissatgesCarpetaTaulell = BoardFolderMessageList
					.JSONtoMessagesList(result);
			ArrayList<BoardFolderMessage> missatgesCarpetaTaulell = llistaMissatgesCarpetaTaulell
					.getMessages();
			Log.v("BoardFolderMessages",
					"mida:" + missatgesCarpetaTaulell.size());
			ListView lstMissatgesCarpetes = (ListView) findViewById(R.id.messagesfolderboard_llistamissatge);
			lstMissatgesCarpetes
					.setAdapter(new adaptadorLlistaMissatgesCarpetesTaulell(
							MesaggesFolderBoard_activity.this,
							missatgesCarpetaTaulell));
			lstMissatgesCarpetes.setItemsCanFocus(true);
			lstMissatgesCarpetes
					.setOnItemClickListener(new OnItemClickListener() {

						@Override
						public void onItemClick(AdapterView<?> arg0, View arg1,
								int arg2, long arg3) {
							Log.v("Mensaje Tablon", "Ha hecho click");
							BoardFolderMessage misstageSeleccionat = (BoardFolderMessage) arg0
									.getAdapter().getItem(arg2);
							Intent intent = new Intent(
									MesaggesFolderBoard_activity.this,
									BoardMessageDetails.class);
							Bundle b = new Bundle();
							String conversioJSON = (new Gson())
									.toJson(misstageSeleccionat);
							b.putString("MISSATGE", conversioJSON);
							intent.putExtras(b);
							startActivity(intent);
						}

					});
		}


	}
}
