/******************************************************************************************
 * Fitxer:adaptadorLlistaAlumnes.java
 * Data Creaci:2-dic-2013
 * Ultima Modificacio: 10-dic-2013
 * Autor:Toms Ruiz
 * Projecte: TUTOC - Aplicaci Android enfocada a la gesti dels tutors a UOC
 * Assignatura:TFC-Desenvolupament aplicacions dispositius mbils (Android) Aula 3
 * Consultor:Joan Vicent  Orenga  Serisuelo
 * Descripci:
 * Log:
****************************************************************************************** */
package edu.uoc.tutoc.alumne;

import java.util.ArrayList;

import android.app.Activity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;
import edu.uoc.tutoc.R;

/**
 * Classe: Projecte:TUTOC.
 * 
 * @desc: Package:edu.uoc.tutoc.alumne Data Creacio:23/11/2013
 * @author: <A HREF="mailto:truizso@uoc.edu">Toms Ruiz</A>
 * @version:0.0 Log: Revision 23/11/2013 Inicial
 * @see [String]
 * @see [URL]
 * @see [Class name#method name]
 * @example
 * @todo
 * @precondition
 * @postcondition
 * @summary
 * @bug *
 */
public class adaptadorLlistaAlumnes extends BaseAdapter {
	
	/** El activitat. */
	private final Activity activitat;
	
	/** El alumnes. */
	private final ArrayList<Alumne> alumnes;

	/**
	 * Constructor
	 * 
	 * *.
	 * 
	 * @param activitat
	 *            : activitat
	 * @param alumnes
	 *            : alumnes
	 * @desc: Instancia una nova adaptador llista alumnes. esttica: false
	 * @date: 10-dic-2013 21:43:46 package: edu.uoc.tutoc.alumne
	 */

	public adaptadorLlistaAlumnes(Activity activitat, ArrayList<Alumne> alumnes) {
		super();
		this.activitat = activitat;
		this.alumnes = alumnes;

	}

	/**
	 * Obt el count.
	 * 
	 * @return the count
	 * @desc Mtode sobrescrigut de @see android.widget.Adapter#getCount()
	 *       <p>
	 * @version: 1.0
	 * @autor: Toms Ruiz
	 * @params:
	 * @return: el valor de
	 * @exception:
	 * @see: @see android.widget.Adapter#getCount()
	 * @see [String]
	 * @see [URL]
	 * @see [Class name#method name]
	 * @example
	 * @todo
	 * @precondition
	 * @postcondition
	 * @summary Devuelve la cantidad total de elementos en l alista
	 * @bug
	 */

	@Override
	public int getCount() {
		
		return alumnes.size();
	}

	/**
	 * Obt el item.
	 * 
	 * @param position
	 *            : position
	 * @return the item
	 * @desc Mtode sobrescrigut de @see android.widget.Adapter#getItem(int)
	 *       <p>
	 * @version: 1.0
	 * @autor: Toms Ruiz
	 * @params:
	 * @return: el valor de
	 * @exception:
	 * @see: @see android.widget.Adapter#getItem(int)
	 * @see [String]
	 * @see [URL]
	 * @see [Class name#method name]
	 * @example
	 * @todo
	 * @precondition
	 * @postcondition
	 * @summary
	 * @bug
	 */

	@Override
	public Object getItem(int position) {

		return alumnes.get(position);
	}

	/**
	 * Obt el item id.
	 * 
	 * @param position
	 *            : position
	 * @return the item id
	 * @desc Mtode sobrescrigut de @see android.widget.Adapter#getItemId(int)
	 *       <p>
	 * @version: 1.0
	 * @autor: Toms Ruiz
	 * @params:
	 * @return: el valor de
	 * @exception:
	 * @see: @see android.widget.Adapter#getItemId(int)
	 * @see [String]
	 * @see [URL]
	 * @see [Class name#method name]
	 * @example
	 * @todo
	 * @precondition
	 * @postcondition
	 * @summary Devuelve el elemento en una determinada posicin
	 * @bug
	 */

	@Override
	public long getItemId(int position) {
		
		return position;
	}

	/**
	 * Obt el view.
	 * 
	 * @param position
	 *            : position
	 * @param convertView
	 *            : convert view
	 * @param parent
	 *            : parent
	 * @return the view
	 * @desc Mtode sobrescrigut de @see android.widget.Adapter#getView(int,
	 *       android.view.View, android.view.ViewGroup)
	 *       <p>
	 * @version: 1.0
	 * @autor: Toms Ruiz
	 * @params:
	 * @return: el valor de
	 * @exception:
	 * @see: @see android.widget.Adapter#getView(int, android.view.View,
	 *       android.view.ViewGroup)
	 * @see [String]
	 * @see [URL]
	 * @see [Class name#method name]
	 * @example
	 * @todo
	 * @precondition
	 * @postcondition
	 * @summary Devuelve el layout correspondiente a la posicin del elemnto de
	 *          la lista
	 * @bug
	 */

	@Override
	public View getView(int position, View convertView, ViewGroup parent) {
		LayoutInflater inflater = activitat.getLayoutInflater();
		View view = inflater.inflate(R.layout.elementllistaalumne, null, true);
		//try {		
		TextView textview = (TextView) view.findViewById(R.id.nom);
		textview.setText(alumnes.get(position).getFullName());
		textview=(TextView) view.findViewById(R.id.FitxaAlumneTxtNomAula);
		textview.setText(alumnes.get(position).getId());
		return view;
	}
}
