/******************************************************************************************
 * Fitxer:RESTMethod.java
 * Data Creaci:16-nov-2013
 * Ultima Modificacio: 10-dic-2013
 * Autor:Toms Ruiz
 * Projecte: TUTOC - Aplicaci Android enfocada a la gesti dels tutors a UOC
 * Assignatura:TFC-Desenvolupament aplicacions dispositius mbils (Android) Aula 3
 * Consultor:Joan Vicent  Orenga  Serisuelo
 * Descripci:
 * Log:
****************************************************************************************** */
package edu.uoc.tutoc.api.rest;

import org.apache.http.HttpResponse;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.client.methods.HttpPut;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.util.EntityUtils;

import edu.uoc.tutoc.utils.Constant;

import android.util.Log;

/**
 * El Class RESTMethod.
 */
public class RESTMethod {

	/**
	 * Obt el.
	 * 
	 * @param URI
	 *            : uri
	 * @param token
	 *            : token
	 * @return string Tipus: RESTMethod
	 */
	public static String Get(String URI, String token) {
		URI = Constant.WEBAPPURI + URI;

		HttpClient httpClient = new DefaultHttpClient();
		if (URI.contains("?")) {
			URI = URI + "&";
		} else {
			URI = URI + "?";
		}
		HttpGet httpGet = new HttpGet(URI + "access_token=" + token);
		httpGet.setHeader("content-type", "application/json");
		try {
			Log.v("api call", URI + "access_token=" + token);
			HttpResponse resp = httpClient.execute(httpGet);
			return EntityUtils.toString(resp.getEntity());
		} catch (Exception ex) {
			Log.e("REST", "Error mtode REST:operaci GET", ex);
		}
		return null;
	}

	/**
	 * Put.
	 * 
	 * @param URI
	 *            : uri
	 * @param token
	 *            : token
	 * @param JSONObject
	 *            : jSON object
	 * @return string Tipus: RESTMethod
	 */
	public static String Put(String URI, String token, String JSONObject) {
		HttpClient httpClient = new DefaultHttpClient();
		HttpPut httpPut = new HttpPut(URI + "?access_token=" + token);
		httpPut.setHeader("content-type", "application/json");

		try {

			StringEntity entity = new StringEntity(JSONObject);
			httpPut.setEntity(entity);
			HttpResponse resp = httpClient.execute(httpPut);

			Log.v("PUT Ent", resp.getStatusLine().toString());

			String putResponseString = EntityUtils.toString(resp.getEntity());
			Log.v("PUT RESPONSE", putResponseString);
			return putResponseString;

		} catch (Exception ex) {
			Log.e("REST", "Error mtode REST:operaci PUT!", ex);
		}
		return null;
	}

	/**
	 * Post.
	 * 
	 * @param URI
	 *            : uri
	 * @param token
	 *            : token
	 * @param JSONObject
	 *            : jSON object
	 * @return string Tipus: RESTMethod
	 */
	public static String Post(String URI, String token, String JSONObject) {
		HttpClient httpClient = new DefaultHttpClient();
		HttpPost httpPost = new HttpPost(URI + "?access_token=" + token);
		httpPost.setHeader("content-type", "application/json");

		try {
			StringEntity entity = new StringEntity(JSONObject);
			httpPost.setEntity(entity);
			HttpResponse resp = httpClient.execute(httpPost);
			return EntityUtils.toString(resp.getEntity());

		} catch (Exception ex) {
			Log.e("REST", "Error mtode REST:operaci PUT!", ex);
		}
		return null;
	}

}
