/******************************************************************************************
 * Fitxer:Application.java
 * Data Creaci:1-nov-2013
 * Ultima Modificacio: 16-nov-2013
 * Autor:Toms Ruiz
 * Projecte: TUTOC - Aplicaci Android enfocada a la gesti dels tutors a UOC
 * Assignatura:TFC-Desenvolupament aplicacions dispositius mbils (Android) Aula 3
 * Consultor:Joan Vicent  Orenga  Serisuelo
 * Descripci:
 * Log:
 ****************************************************************************************** */
package edu.uoc.tutoc.aplicacio;



/**
 * Classe: Aplicacio Projecte:TUTOC Descripcio: Encarregada de portar els valors
 * global de la aplicacio Tutoc Package:edu.uoc.tutoc.aplicacio Data
 * Creacio:01/11/2013
 * 
 * @author: <A HREF="mailto:truizso@uoc.edu">Toms Ruiz</A>
 * @version:0.0 Log: Revision 01/11/2011 Inicial
 * @see [String]
 * @see [URL]
 * @see [Class name#method name]
 * 
 ***/
public class Applicacio {
	private int version; // Versi de la aplicaci

	private int compilation; // Nombre de compilaci

	private Opcio configuracio; // Configuraci del aplicatiu

	private boolean online; // Comprovar si la pgina t accs a online o no

	private String token; // Token que es rep de la autentificaci

	private Tutor propietari; // Tutor que s el propietari de la aplicaci

	private Manager manager; // Classe Manager que s'encarrega de gestionar les
								// diferents funcionalitats


	private static Applicacio instance = null;

	// Es diu que aquesta classe no es pot instanciar ja que volem una mateixa
	// classe durant l'execuci

	private Applicacio() {

	}

	/**
	 * Retorna la version
	 * <p>
	 * Aquest mtode retornar version
	 * 
	 * @param:
	 * @return: version tipus: int
	 * @see:#version
	 * @throws:
	 */
	public int getVersion() {
		return version;
	}

	/**
	 * Dna Valor al version
	 * <p>
	 * Posa com valor de version el version
	 * 
	 * @param:version Tipus: int
	 * @return: void
	 * @see:#version
	 * @throws:
	 */
	public void setVersion(int version) {
		this.version = version;
	}

	/**
	 * Retorna el compilation
	 * <p>
	 * Aquest mtode retornar compilation
	 * 
	 * @param:
	 * @return: compilation tipus: int
	 * @see:#compilation
	 * @throws:
	 */
	public int getCompilation() {
		return compilation;
	}

	/**
	 * Dna Valor al compilation
	 * <p>
	 * Posa com valor de compilation el compilation
	 * 
	 * @param:compilation Tipus: int
	 * @return: void
	 * @see:#compilation
	 * @throws:
	 */
	public void setCompilation(int compilation) {
		this.compilation = compilation;
	}

	/**
	 * Retorna el configuracio
	 * <p>
	 * Aquest mtode retornar configuracio
	 * 
	 * @param:
	 * @return: configuracio tipus: Opcio
	 * @see:#configuracio
	 * @throws:
	 */
	public Opcio getConfiguracio() {
		return configuracio;
	}

	/**
	 * Dna Valor al configuracio
	 * <p>
	 * Posa com valor de configuracio el configuracio
	 * 
	 * @param:configuracio Tipus: Opcio
	 * @return: void
	 * @see:#configuracio
	 * @throws:
	 */
	public void setConfiguracio(Opcio configuracio) {
		this.configuracio = configuracio;
	}

	/**
	 * Retorna el online
	 * <p>
	 * Aquest mtode retornar online
	 * 
	 * @param:
	 * @return: online tipus: boolean
	 * @see:#online
	 * @throws:
	 */
	public boolean isOnline() {
		return online;
	}

	/**
	 * Dna Valor al online
	 * <p>
	 * Posa com valor de online el online
	 * 
	 * @param:online Tipus: boolean
	 * @return: void
	 * @see:#online
	 * @throws:
	 */
	public void setOnline(boolean online) {
		this.online = online;
	}

	/**
	 * Retorna el token
	 * <p>
	 * Aquest mtode retornar token
	 * 
	 * @param:
	 * @return: token tipus: String
	 * @see:#token
	 * @throws:
	 */
	public String getToken() {
		return token;
	}

	/**
	 * Dna Valor al token
	 * <p>
	 * Posa com valor de token el token
	 * 
	 * @param:token Tipus: String
	 * @return: void
	 * @see:#token
	 * @throws:
	 */
	public void setToken(String token) {
		this.token = token;
	}

	/**
	 * Retorna el propietari
	 * <p>
	 * Aquest mtode retornar propietari
	 * 
	 * @param:
	 * @return: propietari tipus: Tutor
	 * @see:#propietari
	 * @throws:
	 */
	public Tutor getPropietari() {
		return propietari;
	}

	/**
	 * Dna Valor al propietari
	 * <p>
	 * Posa com valor de propietari el propietari
	 * 
	 * @param:propietari Tipus: Tutor
	 * @return: void
	 * @see:#propietari
	 * @throws:
	 */
	public void setPropietari(Tutor propietari) {
		this.propietari = propietari;
	}

	/**
	 * Retorna el manager
	 * <p>
	 * Aquest mtode retornar manager
	 * 
	 * @param:
	 * @return: manager tipus: Manager
	 * @see:#manager
	 * @throws:
	 */
	public Manager getManager() {
		return manager;
	}

	/**
	 * Dna Valor al manager
	 * <p>
	 * Posa com valor de manager el manager
	 * 
	 * @param:manager Tipus: Manager
	 * @return: void
	 * @see:#manager
	 * @throws:
	 */
	public void setManager(Manager manager) {
		this.manager = manager;
	}



	/**
	 * Dna Valor al instance
	 * <p>
	 * Posa com valor de instance el instance
	 * 
	 * @param:instance Tipus: Application
	 * @return: void
	 * @see:#instance
	 * @throws:
	 */
	public static void setInstance(Applicacio instance) {
		Applicacio.instance = instance;
	}

	public static Applicacio getInstance() {
		if (instance == null) {
			instance = new Applicacio();
		}
		return instance;

	}

	public void Run() {

	}

	public void MostrarMenuPrincipal() {

	}

}
