/******************************************************************************************
 * Fitxer:Missatge.java
 * Data Creaci:17-nov-2013
 * Ultima Modificacio: 17-nov-2013
 * Autor:Toms Ruiz
 * Projecte: TUTOC - Aplicaci Android enfocada a la gesti dels tutors a UOC
 * Assignatura:TFC-Desenvolupament aplicacions dispositius mbils (Android) Aula 3
 * Consultor:Joan Vicent  Orenga  Serisuelo
 * Descripci:
 * Log:
 ****************************************************************************************** */
package edu.uoc.tutoc.aplicacio;

import java.util.Date; //Necessari pels camps data

/**
 * Classe: Missatge Projecte:TUTOC Descripcio:S'encarrega de portar el missatge
 * al campus Package:edu.uoc.tutoc.aplicacio Data Creacio:17-nov-2013
 * 
 * @author: <A HREF="mailto:truizso@uoc.edu">Toms Ruiz</A>
 * @version:0.0 Log: Revision 01/11/2011 Inicial
 * @see [String]
 * @see [URL]
 * @see [Class name#method name]
 * 
 ***/
public abstract class Missatge {
	private long id; // Identificador del missatge
	private String assumpte; // Assumpte del missaatge
	private Date dataCreacio; // Data de creaci del missatge
	private Date dataEnviament; // Data d'enviament del missatge
	private Persona receptor; // Receptor del missatge
	private Persona autor; // Autor del missatge
	private String estat; // Estat intern del missatge
	private boolean llegit = false; // Estat que ens diu si ha estat llegit o no

	/**
	 * Retorna el id
	 * <p>
	 * Aquest mtode retornar id
	 * 
	 * @param:
	 * @return: id tipus: long
	 * @see:#id
	 * @throws:
	 */
	public long getId() {
		return id; // Es retorna id
	}

	/**
	 * Dna Valor al id
	 * <p>
	 * Posa com valor de id el id
	 * 
	 * @param:id Tipus: long
	 * @return: void
	 * @see:#id
	 * @throws:
	 */
	public void setId(long id) {
		this.id = id; // Se assigna el valor
	}

	/**
	 * Retorna el assumpte
	 * <p>
	 * Aquest mtode retornar assumpte
	 * 
	 * @param:
	 * @return: assumpte tipus: String
	 * @see:#assumpte
	 * @throws:
	 */
	public String getAssumpte() {
		return assumpte; // Es retorna assumpte
	}

	/**
	 * Dna Valor al assumpte
	 * <p>
	 * Posa com valor de assumpte el assumpte
	 * 
	 * @param:assumpte Tipus: String
	 * @return: void
	 * @see:#assumpte
	 * @throws:
	 */
	public void setAssumpte(String assumpte) {
		this.assumpte = assumpte; // Se assigna el valor
	}

	/**
	 * Retorna el dataCreacio
	 * <p>
	 * Aquest mtode retornar dataCreacio
	 * 
	 * @param:
	 * @return: dataCreacio tipus: Date
	 * @see:#dataCreacio
	 * @throws:
	 */
	public Date getDataCreacio() {
		return dataCreacio; // Es retorna dataCreacio
	}

	/**
	 * Dna Valor al dataCreacio
	 * <p>
	 * Posa com valor de dataCreacio el dataCreacio
	 * 
	 * @param:dataCreacio Tipus: Date
	 * @return: void
	 * @see:#dataCreacio
	 * @throws:
	 */
	public void setDataCreacio(Date dataCreacio) {
		this.dataCreacio = dataCreacio; // Se assigna el valor
	}

	/**
	 * Retorna el dataEnviament
	 * <p>
	 * Aquest mtode retornar dataEnviament
	 * 
	 * @param:
	 * @return: dataEnviament tipus: Date
	 * @see:#dataEnviament
	 * @throws:
	 */
	public Date getDataEnviament() {
		return dataEnviament; // Es retorna dataEnviament
	}

	/**
	 * Dna Valor al dataEnviament
	 * <p>
	 * Posa com valor de dataEnviament el dataEnviament
	 * 
	 * @param:dataEnviament Tipus: Date
	 * @return: void
	 * @see:#dataEnviament
	 * @throws:
	 */
	public void setDataEnviament(Date dataEnviament) {
		this.dataEnviament = dataEnviament; // Se assigna el valor
	}

	/**
	 * Retorna el receptor
	 * <p>
	 * Aquest mtode retornar receptor
	 * 
	 * @param:
	 * @return: receptor tipus: Persona
	 * @see:#receptor
	 * @throws:
	 */
	public Persona getReceptor() {
		return receptor; // Es retorna receptor
	}

	/**
	 * Dna Valor al receptor
	 * <p>
	 * Posa com valor de receptor el receptor
	 * 
	 * @param:receptor Tipus: Persona
	 * @return: void
	 * @see:#receptor
	 * @throws:
	 */
	public void setReceptor(Persona receptor) {
		this.receptor = receptor; // Se assigna el valor
	}

	/**
	 * Retorna el autor
	 * <p>
	 * Aquest mtode retornar autor
	 * 
	 * @param:
	 * @return: autor tipus: Persona
	 * @see:#autor
	 * @throws:
	 */
	public Persona getAutor() {
		return autor; // Es retorna autor
	}

	/**
	 * Dna Valor al autor
	 * <p>
	 * Posa com valor de autor el autor
	 * 
	 * @param:autor Tipus: Persona
	 * @return: void
	 * @see:#autor
	 * @throws:
	 */
	public void setAutor(Persona autor) {
		this.autor = autor; // Se assigna el valor
	}

	/**
	 * Retorna el estat
	 * <p>
	 * Aquest mtode retornar estat
	 * 
	 * @param:
	 * @return: estat tipus: String
	 * @see:#estat
	 * @throws:
	 */
	public String getEstat() {
		return estat; // Es retorna estat
	}

	/**
	 * Dna Valor al estat
	 * <p>
	 * Posa com valor de estat el estat
	 * 
	 * @param:estat Tipus: String
	 * @return: void
	 * @see:#estat
	 * @throws:
	 */
	public void setEstat(String estat) {
		this.estat = estat; // Se assigna el valor
	}

	/**
	 * Retorna el llegit
	 * <p>
	 * Aquest mtode retornar llegit
	 * 
	 * @param:
	 * @return: llegit tipus: boolean
	 * @see:#llegit
	 * @throws:
	 */
	public boolean isLlegit() {
		return llegit; // Es retorna llegit
	}

	/**
	 * Dna Valor al llegit
	 * <p>
	 * Posa com valor de llegit el llegit
	 * 
	 * @param:llegit Tipus: boolean
	 * @return: void
	 * @see:#llegit
	 * @throws:
	 */
	public void setLlegit(boolean llegit) {
		this.llegit = llegit; // Se assigna el valor
	}

	/**
	 * @return
	 */
	public Missatge crearMissatge() {
		return null;
	}

	/**
	 * @param id
	 * @return
	 */
	public Missatge esborrarMissatge(long id) {
		return null;
	}

	/**
	 * @param id_Missatge
	 */
	public void respondre(long id_Missatge) {

	}

	/**
	 * @return
	 */
	public Missatge mostrarMissatge() {
		return null;
	}

}
